set fglScriptVersion  2.26
##########################
# interface
# all functions must exist in tcl script

# fgl_ListCreate
# fgl_ListSet
# fgl_ListState
# fgl_ListSelect
# fgl_ListFocus
# fgl_ListScroll
# fgl_EntryCreate
# fgl_EntrySet
# fgl_EntryState
# fgl_EntrySelect
# fgl_EntryFocus
# fgl_EntryConfigure
# fgl_QueryCreate
# fgl_QuerySet
# fgl_QueryDestroy
# fgl_WindowOpen
# fgl_WindowClose
# fgl_WindowSelect
# fgl_WindowClear
# fgl_WindowSetOptions
# fgl_FormDisplay
# fgl_MenuCreateV
# fgl_MenuCreateH
# fgl_MenuFieldCreateH
# fgl_MenuFieldCreateV
# fgl_MenuEnableH
# fgl_MenuEnableV
# fgl_MenuDestroyH
# fgl_MenuDestroyV
# fgl_MenuFocusH
# fgl_MenuFocusV
# fgl_DisplayAt
# fgl_ClearToEol
# fgl_LineH
# fgl_Box
# fgl_Label
# fgl_Comment
# fgl_Message
# fgl_Error
# fgl_Prompt ????????
# fgl_Pdm
# fgl_TaskOpen
# fgl_TaskClose
# fgl_TaskSelect
# fgl_TermSelect
# fgl_ShellMode
# fgl_WindowMode
# fgl_Bell
# fgl_Exit
# fgl_ButtonSet
# fgl_ButtonCreate
# fgl_ButtonFrameCreate
# fgl_ButtonFrameSeparate
# fgl_ButtonFrameDestroy
# fgl_ErrorDestroy
# fgl_ScrollBarCreate
# fgl_ScrollBarConfigure
# fgl_ScrollBarDestroy
# fgl_Retrieve
# fgl_PromptCreate
# fgl_PromptSet
# fgl_PromptDestroy
# fgl_TaskConfigure
# fgl_ReportBegin
# fgl_ReportPageBegin
# fgl_ReportRow
# fgl_ReportPageEnd
# fgl_ReportEnd
################################################################################

if { [info globals fglWtkClient]== "" } {
  set fglWtkClient 0
  } else {
  catch {fglwtk_ShowStartUp}
}

# New After command

if { [info command after4] == "after4" } {
  rename after oldAfter
  rename after4 after
}

################################################################################

set fglUseColor     0 ; catch { set fglUseColor $env(FGLCOLOR) }
set fglUseOob       1 ; catch { set fglUseOob $env(FGLUSEOOB) }
set fglUseBgColor   1
if { $fglWtkClient } {
    set fgldir $wtk_clientdir/..
  } else {
    set fgldir "/usr/fgl2c"
    catch {set fgldir $env(FGLDIR)}
}
set tkOrgEntrys     1
set tkOrgScrollbars 0
set tkOrgButtons    0
set wtkchilds_clip_siblings 1
set tk_strictMotif  0
set fglReport(printer)     ""
set fglReport(driver)     ""
set fglReport(port)     ""
set fglReport(papersize)   a4
set fglReport(orientation) portrait
set fglReport(color)       mono
set fglReport(font)        ""
set fglReport(fontpoints)  13
#printer ,which was used for fontselection
set fglReport(fontprinter) ""
set fglReport(cpi)         10
set fglReport(use_default_font)         1
set fglReport(use_hardcopy_rects)       1
set fglReport(pixel_hardcopy) 1

################################################################################
# globals

set wnd(screen,dimX) 25
set _task(INITIAL) initial
set groupL(0)    0
set taskRoot "xxxxxxxx"
set topWnd   .
set dpyChannel -1
set promptTop ""
set queryLine ""
set yahoo 0

###############################################################################
# internal

proc fglSetClientSpecifics { } {
  global fglWtkClient fglConfigFile fglFontFamilyButton fglFont
  if { $fglWtkClient } {
    option add *FglListbox.rPad 0 userDefault
    set fglFontFamilyButton "Arial"
    set fglFont "Courier-Normal-10"
  } else {
    wm withdraw .
    set fglFontFamilyButton "helvetica"
    set fglFont "7x14"
  }
  set fglConfigFile "[fglSearchConfigFileName]"
  option add *font $fglFont userDefault
}

proc fglSearchConfigFileName { {name {}} } {
  global fglWtkClient env
  set name [fglExpandPath $name]
  if { [ string match "\/*" "$name" ] || [ string match "\\\\*" "$name" ] } {
    set foundName "$name"
    if {![file exist $foundName]} {
      puts stderr "Cannot open config file \"$foundName\""
    }
  } elseif { $fglWtkClient } {
    if { $name == "" } { set name locals.tcl }
    if {[catch getwindowsdirectory dir]} {set dir .}
    set locals "$dir/$name"
    if {[file exist $locals]} {
      set foundName $locals
    } else {
      set foundName "$name"
    }
  } else {
    if { $name == "" } { 
      catch { set foundName "$env(HOME)/.fgl2crc" }
    } else {
      set foundName "$name"
    }
  }
#  puts stderr "#fglSearchConfigFileName is  $foundName"
  return $foundName
}

proc fglExpandPath { name } {
  if { [string range $name  0 0 ] == "$" } {
    global env
    if { [set pos [string first / $name]] == -1 } {
      set pos end
      set end ""
    } else {
      set end [string range $name $pos end] 
      incr pos -1
    }
    set var [string range $name 1 $pos]
#    puts stderr "#var is $var [ info exist env($var)]"
    if { [ info exist env($var)] } {
      set name "$env($var)${end}"
    } else {
      set name "${end}"
    }
  }
  return $name
}

proc fglOptionAdd2 { } {
  global fglUseColor fglUseBgColor config

  option add *foreground black userDefault
  option add *buttonPadX 5 userDefault
  option add *formPadX 4 userDefault
  option add *formPadY 4 userDefault
  option add *entryPadY 2 userDefault

  if { $fglUseColor } {
    set bgN cyan3
    set bgH gray75
    option add *entryActiveBg gray75 userDefault
  } {
    set bgN gray90
    set bgH gray75
    option add *entryActiveBg gray95 userDefault
  }
  option add *FglEntry.flatwin       1 userDefault
  option add *FglLabel.flatwin       1 userDefault
  option add *Label.flatwin          1 userDefault
  option add *FglButtonKey.flatwin   1 userDefault
  option add *FglButtonMenuV.flatwin 1 userDefault
  option add *FglLineV.flatwin       1 userDefault
  option add *FglLineH.flatwin       1 userDefault
  option add *FglLine.flatwin        1 userDefault
  option add *defaultBg                      $bgN  userDefault
  option add *FglEntry.background            $bgN  userDefault
  option add *FglEntry.highlightBackground   $bgH  userDefault
  option add *FglListbox.background          $bgN  userDefault
  option add *FglListbox.highlightForeground black userDefault
  option add *FglListbox.highlightBackground $bgH  userDefault

  option add *colorWhite    black userDefault
  option add *colorYellow   #ffff00 userDefault
  option add *colorMagenta  #ff00ff userDefault
  option add *colorRed      #ff0000 userDefault
  option add *colorCyan     #00ffff userDefault
  option add *colorGreen    #00ff00 userDefault
  option add *colorBlue     #00007f userDefault
  option add *colorBlack    black userDefault

  set config(defaultBg)      [option get . defaultBg ""]

  option add *bgcolorWhite    $config(defaultBg) userDefault
  option add *bgcolorBlack    $config(defaultBg) userDefault

  if { $fglUseBgColor } {
    option add *bgcolorYellow   #ffff80 userDefault
    option add *bgcolorMagenta  #ff80ff userDefault
    option add *bgcolorRed      #ff8080 userDefault
    option add *bgcolorCyan     #80ffff userDefault
    option add *bgcolorGreen    #80ff00 userDefault
    option add *bgcolorBlue     #8080ff userDefault
  } {
    option add *bgcolorYellow   $config(defaultBg) userDefault
    option add *bgcolorMagenta  $config(defaultBg) userDefault
    option add *bgcolorRed      $config(defaultBg) userDefault
    option add *bgcolorCyan     $config(defaultBg) userDefault
    option add *bgcolorGreen    $config(defaultBg) userDefault
    option add *bgcolorBlue     $config(defaultBg) userDefault
  }

  option add *background $config(defaultBg) userDefault

  option add *FglFrame.background  $config(defaultBg) userDefault
  option add *FglFrame.borderWidth 4 userDefault
  option add *FglFrame.relief ridge userDefault

  option add *FglFrameTask.background  $config(defaultBg) userDefault
  option add *FglFrameTask.borderWidth 0 userDefault
  option add *FglFrameTask.relief flat  userDefault

  option add *FglMenuFrame.relief flat userDefault
  option add *FglMenuFrame.borderWidth 0 userDefault

  option add *FglKeyFrame.relief raised userDefault
  option add *FglKeyFrame.borderWidth 1 userDefault

  option add *FglPromptFrame.relief flat userDefault
  option add *FglPromptFrame.borderWidth 0 userDefault

  option add *FglEntry.borderWidth 1   userDefault
  option add *FglEntry.relief sunken userDefault
  option add *FglEntry.selectBorderWidth 1 100
  option add *FglEntry.exportSelection 0 100

  option add *FglListbox.background  $config(defaultBg) userDefault
  option add *FglListbox.borderWidth 1   userDefault
  option add *FglListbox.relief sunken userDefault
  option add *FglListbox.exportSelection 0 100
  option add *FglListbox.selectMode browse 100

  option add *FglFirstLabel.background  $config(defaultBg) userDefault
  option add *FglFirstLabel.borderWidth 1   userDefault
  option add *FglFirstLabel.relief sunken userDefault

  option add *FglOtherLabel.background  $config(defaultBg) userDefault
  option add *FglOtherLabel.borderWidth 1   userDefault
  option add *FglOtherLabel.relief sunken userDefault

  option add *FglLine.background  $config(defaultBg) userDefault
  option add *FglLine.borderWidth 1   userDefault
  option add *FglLine.relief raised userDefault
  option add *FglLine.height 2 userDefault

  option add *FglMessage.background  $config(defaultBg) userDefault
  option add *FglMessage.borderWidth 1   userDefault
  option add *FglMessage.relief sunken userDefault

#  option add *FglButtonKey.font $fglFont userDefault
  option add *FglButtonKey.activeBackground gray95 userDefault
  option add *FglButtonKey.background $config(defaultBg) userDefault
  option add *FglButtonKey.borderWidth 2 userDefault
  option add *FglButtonKey.width 15 userDefault
  option add *FglButtonKey.padX 0 userDefault
  option add *FglButtonKey.padY 0 userDefault

  option add *FglButtonMenuV.activeBackground gray95 userDefault
  option add *FglButtonMenuV.background $config(defaultBg) userDefault
  option add *FglButtonMenuV.borderWidth 2 userDefault
  option add *FglButtonMenuV.width 15 userDefault
  option add *FglButtonMenuV.padX 0 userDefault
  option add *FglButtonMenuV.padY 0 userDefault

  option add *FglButtonMenu.activeBackground gray95 userDefault
  option add *FglButtonMenu.background $config(defaultBg) userDefault
  option add *FglButtonMenu.borderWidth 2 userDefault
  option add *FglButtonMenu.padX 0 userDefault
  option add *FglButtonMenu.padY 0 userDefault
  option add *FglButtonMenu.relief raised userDefault

  option add *FglMenuNameH.background $config(defaultBg) userDefault
  option add *FglMenuNameH.relief raised userDefault
  option add *FglMenuNameH.borderWidth 2 userDefault
  option add *FglMenuNameH.padX 0 userDefault
  option add *FglMenuNameH.padY 0 userDefault

  option add *FglButtonMenuX.activeBackground gray95 userDefault
  option add *FglButtonMenuX.background $config(defaultBg) userDefault
  option add *FglButtonMenuX.borderWidth 2 userDefault
  option add *FglButtonMenuX.padX 0 userDefault
  option add *FglButtonMenuX.padY 0 userDefault

  option add *FglLabelBubble.foreground black userDefault
  option add *FglLabelBubble.background yellow userDefault
  option add *FglLabelBubble.padX 2 userDefault
  option add *FglLabelBubble.padY 2 userDefault

  option add *FglMenuName.background $config(defaultBg) userDefault
  option add *FglMenuName.width  15 userDefault
  option add *FglMenuName.relief groove userDefault
  option add *FglMenuName.borderWidth 2 userDefault

  option add *FglBMPKey.activeBackground gray95 userDefault
  option add *FglBMPKey.background $config(defaultBg) userDefault
  option add *FglBMPKey.borderWidth 2 userDefault
  option add *FglBMPKey.padX 0 userDefault
  option add *FglBMPKey.padY 0 userDefault

  option add *FglError.background $config(defaultBg) userDefault
  option add *FglError.relief raised userDefault
  option add *FglError.borderWidth 1 userDefault

  option add *FglScrollbar.activeForeground $config(defaultBg)  userDefault
  option add *FglScrollbar.foreground $config(defaultBg)  userDefault
  option add *FglScrollbar.background $config(defaultBg)  userDefault
  option add *FglScrollbar.borderWidth 1 100
  option add *FglScrollbar.relief sunken 100

  option add *FglRadioFrame.background $config(defaultBg) userDefault
  option add *FglRadioFrame.relief flat  userDefault
  option add *FglRadioFrame.borderWidth 0 userDefault

  option add *FglRadioButton.activeBackground gray95 userDefault
  option add *FglRadioButton.disabledForeground gray45 userDefault
  option add *FglRadioButton.background $config(defaultBg) userDefault
  option add *FglRadioButton.relief flat  userDefault
  option add *FglRadioButton.borderWidth 2 userDefault
  option add *FglRadioButton.padX 0 userDefault
  option add *FglRadioButton.padY 0 userDefault

  option add *FglCheckButton.activeBackground gray95 userDefault
  option add *FglCheckButton.disabledForeground gray45 userDefault
  option add *FglCheckButton.background $config(defaultBg) userDefault
  option add *FglCheckButton.borderWidth 2 userDefault
  option add *FglCheckButton.padX 0 userDefault
  option add *FglCheckButton.padY 0 userDefault

}

proc tk_bindcpy { destclass srclass } {
  foreach i [bind $srclass] {
    if { [catch {bind $srclass $i} bind ]} {
#      puts stderr "#binderror $i $srclass $bind"
      continue
    }
    if {[catch {bind $destclass $i  $bind} msg]} {
#      puts stderr "#binderror2 $i $destclass $srclass $msg"
    }
  }
}

#proc fglBindCpy { } {
#  tk_bindcpy FglButtonMenu Button
#  tk_bindcpy FglButtonKey  Button
#  tk_bindcpy FglBMPKey     Button
#  tk_bindcpy FglScrollbar  Scrollbar
#  tk_bindcpy FglToplevel   Toplevel
#}

set tk_derived(0) ""
proc fglSetDerivedClasses { } {
  global tk_derived
  set tk_derived(FglBMPKey)      Button
  set tk_derived(FglButtonKey)   Button
  set tk_derived(FglButtonMenu)  Button
  set tk_derived(FglButtonMenuX) Button
  set tk_derived(FglButtonMenuV) Button
  set tk_derived(FglScrollbar)   Scrollbar
  set tk_derived(FglTopLevel)    Toplevel
  set tk_derived(FglEntry)       Entry
  set tk_derived(FglFirstLabel)  Label
  set tk_derived(FglOtherLabel)  Label
  set tk_derived(FglListbox)     Listbox
  set tk_derived(FglFrameTask)   Frame
  set tk_derived(FglMessage)     Entry
  set tk_derived(FglMenuName)    Label
  set tk_derived(FglToolbarButton)     Button
  set tk_derived(FglLine)        Frame
  set tk_derived(FglFrame)       Frame
  set tk_derived(FglLabel)       Label
  set tk_derived(FglLabelBubble) Label
  set tk_derived(FglKeyFrame)    Frame
  set tk_derived(FglPromptFrame) Frame
  set tk_derived(FglError)       Label
  set tk_derived(FglRadioFrame)  Frame
  set tk_derived(FglRadioButton) Radiobutton
  set tk_derived(FglCheckButton) Checkbutton
  set tk_derived(Button)         Button
  set tk_derived(Frame)          Frame
  set tk_derived(Scrollbar)      Scrollbar
  set tk_derived(Toplevel)       Toplevel
  set tk_derived(Entry)          Entry
  set tk_derived(Label)          Label
  set tk_derived(Listbox)        Listbox
  set tk_derived(Radiobutton)    Radiobutton
  set tk_derived(Checkbutton)    Checkbutton
}

proc fglOptionAdd { } {
  global config fglWindowAddY fglWindowAddX attr
  set config(buttonPadX)   [option get . buttonPadX ""]
  set config(formPadX)     [option get . formPadX ""]
  set config(formPadY)     [option get . formPadY ""]
  set config(entryPadY)    [option get . entryPadY ""]
  global fglReport
  foreach i [array names fglReport] {
    if { [ set opt [option get . report_$i ""]]!="" } {
      puts stderr "#setting fglReport\($i\) to $opt"
      set fglReport($i) $opt
    }
  }
  frame .f -class FglFrame
  set config(WindowBorder) [lindex [.f config -borderwidth] 4]
  option add *FglLabel.background [lindex [.f config -background] 4] 100
  destroy .f
  option add *FglLabel.borderWidth 0 userDefault
  option add *FglLabel.padX 0 userDefault
  entry .e -class FglEntry
  option add *FglLabel.padY [lindex [.e config -borderwidth] 4] userDefault
  set config(bgEntryNormal)    [lindex [.e config -background] 4]
  set config(bgEntryActive)    [option get . entryActiveBg ""]
  option add *FglListbox.activeBackground  $config(bgEntryActive) userDefault
  set config(bgEntryHighlight) [lindex [.e config -highlightbackground] 4]
  set attr(FglEntryNormal,background)  [lindex [.e config -background] 4]
  set attr(FglEntryNormal,relief)      [lindex [.e config -relief] 4]
  set attr(FglEntryNormal,borderwidth) [lindex [.e config -borderwidth] 4]
  set attr(FglEntryActive,background)  $config(bgEntryActive)
  set attr(FglEntryActive,relief)      $attr(FglEntryNormal,relief)
  set attr(FglEntryActive,borderwidth) $attr(FglEntryNormal,borderwidth)
  destroy .e
  entry .e -class FglListbox
  set config(bgListboxNormal)    [lindex [.e config -background] 4]
  set config(bgListboxActive)    [option get .e activeBackground FglListbox]
  destroy .e
  label .lb -class FglLabelBubble
  set config(bgBubble)  [lindex [.lb config -background] 4]
  destroy .lb

  set config(White)   [option get . colorWhite ""]
  set config(Yellow)  [option get . colorYellow ""]
  set config(Magenta) [option get . colorMagenta ""]
  set config(Red)     [option get . colorRed ""]
  set config(Cyan)    [option get . colorCyan ""]
  set config(Green)   [option get . colorGreen ""]
  set config(Blue)    [option get . colorBlue ""]
  set config(Black)   [option get . colorBlack ""]

  set config(bgcolorWhite)   [option get . bgcolorWhite ""]
  set config(bgcolorYellow)  [option get . bgcolorYellow ""]
  set config(bgcolorMagenta) [option get . bgcolorMagenta ""]
  set config(bgcolorRed)     [option get . bgcolorRed ""]
  set config(bgcolorCyan)    [option get . bgcolorCyan ""]
  set config(bgcolorGreen)   [option get . bgcolorGreen ""]
  set config(bgcolorBlue)    [option get . bgcolorBlue ""]
  set config(bgcolorBlack)   [option get . bgcolorBlack ""]

  set fglWindowAddX   [ expr 2 * $config(formPadX) + 2]
  set fglWindowAddY   [ expr 2 * $config(formPadY) ]

  button .bm -class FglButtonMenu
  set config(menuButtonRelief)  [lindex [.bm config -relief] 4]
  destroy .bm
}

proc fglBindDefault { } {
  global bindClass
  foreach i [bind FglEntry] {
    bind FglEntry $i { }
  }
  set bindClass "FglEntry FglButtonKey FglRadioButton FglCheckButton \
                 FglListbox FglButtonMenu FglButtonMenuX FglFrameTask \
                 FglMessage FglMenuName FglBMPKey FglButtonMenuV"

  bind FglEntry <Any-KeyPress>          "fglXX %W \[fglKeyPad %A %K %k\]"
  bind FglEntry <Return>                "fglXX %W %K"
  bind FglEntry <Left>                  "fglXX %W %K"
  bind FglEntry <Right>                 "fglXX %W %K"
  bind FglEntry <Control-KeyPress>      "fglXX %W Control-%K"
  bind FglEntry <Mod1-KeyPress>         "fglXX %W Alt-%K"
  bind FglEntry <Mod1-Control-KeyPress> "fglXX %W Alt-Control-%K"
  bind FglEntry <Double-1>              "fglXX %W KEY_accept"
  bind FglEntry <3>              	"fglXX %W F36"
  bind FglEntry <Control-r>             "fglX7 %W"
  bind FglEntry <Control-c>             "fglX6 %W Control-c"
  bind FglEntry <Mod2-Key-Tab>          "puts stderr \"Alt Tab %W \""
  bind FglEntry <FocusOut>              "fglFocusOut %W"
  bind FglEntry <Destroy>               "fglDestroy  %W"
  for {set i 1} {$i<=12} {incr i} {
    bind FglEntry <Shift-F${i}> "fglXX %W F[expr $i+12]"
  }
  for {set i 1} {$i<=12} {incr i} {
    bind FglEntry <Control-F${i}> "fglXX %W F[expr $i+24]"
  }
  tk_bindcpy FglListbox     FglEntry
  tk_bindcpy FglButtonMenu  FglEntry
  tk_bindcpy FglButtonMenuX  FglEntry
  tk_bindcpy FglFrameTask   FglEntry
  tk_bindcpy FglMessage     FglEntry
  tk_bindcpy FglMenuName    FglEntry

#  tk_bindcpy FglButtonMenu Button
  tk_bindcpy FglButtonKey  Button
  tk_bindcpy FglToolbarButton    Button
  tk_bindcpy FglBMPKey     Button
#  tk_bindcpy FglScrollbar  Scrollbar
#  tk_bindcpy FglToplevel   Toplevel
  bind FglToolbarButton <Any-Enter>  { tk_butEnter %W ; fglBubbleEnter %W %x %y}
  bind FglToolbarButton <Any-Leave>  { tk_butLeave %W ; fglBubbleLeave %W %x %y}
  bind FglToolbarButton <Any-Motion> { fglBubbleMotion %W %x %y}
  bind FglToolbarButton <1>          { tk_butDown %W ;fglBubbleButton1 %W %x %y}
  bind FglToolbarButton <ButtonRelease-1>  { tk_butUp %W }

  bind FglEntry   <1>        "fglX1 %W %x"
  bind FglMessage <1>        "fglX1 %W %x"
  bind FglListbox <1>        "fglX2 %W %x %y"
  bind FglEntry   <FocusOut> "fglFocusOutEntry %W"
  bind FglListbox <FocusOut> "fglX22 %W;fglFocusOut %W"

#  bind FglButtonMenu <Any-KeyPress>       "fglXX %W %K"
  bind FglButtonMenu <Any-Enter>          "fglX4 %W"
  bind FglButtonMenu <KeyPress-Return>    { tk_butEnter %W; tk_butDown %W;fglX3 %W; }
  bind FglButtonMenu <KeyRelease-Return>  { }
  bind FglButtonMenu <ButtonPress-1>      { tk_butEnter %W; tk_butDown %W }
  bind FglButtonMenu <ButtonRelease-1>    "fglX3 %W"
  bind FglScrollbar  <ButtonRelease-1>    "fglX5 %W"
  bind FglScrollbar  <ButtonRelease-3>    "fglX5 %W"
  bind FglFrameGroup <FocusIn>            "fglFocusIn  %W"
  tk_bindcpy FglButtonMenuV FglButtonMenu
  global fglWtkClient
  if {$fglWtkClient} {
    catch {
      bind FglEntry <ClientMessage> "fglCbTaskAbort \[w2id %W\] %W"
    }
  }

  bind FglButtonKey <KeyPress-Return>   "%W invoke"
  bind FglButtonKey <KeyRelease-Return> { }
  bind FglButtonKey <ButtonPress-1>     "tk_butDown %W"
  bind FglButtonKey <FocusOut>          "fglButtonKeyFocusOut %W"
  bind FglButtonKey <FocusIn>           "%W configure -state active"
  bind FglButtonKey <Tab>               "fglXX %W %K"
  bind FglButtonKey <Right>             "fglXX %W Tab"
  bind FglButtonKey <Left>              "fglXX %W %K"
  bind FglButtonKey <Up>                "fglXX %W %K"
  bind FglButtonKey <Down>              "fglXX %W %K"
  bind FglButtonKey <Escape>            "fglXX %W %K"
  bind FglButtonKey <Control-r>         "fglX7 %W"
  bind FglButtonKey <Control-c>         "fglX6 %W Control-c"

  tk_bindcpy FglBMPKey FglButtonKey
  bind FglBMPKey <Any-Enter> { }
  bind FglBMPKey <Any-Leave> { }

  bind FglRadioButton <Control-KeyPress>      "fglXX %W Control-%K"
  bind FglRadioButton <Any-KeyPress>   "fglXX %W %K"
  bind FglRadioButton <Down>       "fglRADIODown %W"
  bind FglRadioButton <Up>         "fglRADIOUp %W"
  bind FglRadioButton <Return>     "fglXX %W %K"
  bind FglRadioButton <space>      "fglRADIOSelect %W"
  bind FglRadioButton <1>          "fglRADIOMouseFocus %W"
  bind FglRadioButton <FocusOut>   "fglRADIOFocusOut %W"
#  bind FglRadioButton <FocusIn>    "%W configure -state active"
  bind FglRadioButton <Tab>        "fglXX %W %K"
  bind FglRadioButton <Right>      "fglXX %W Tab"
  bind FglRadioButton <Left>       "fglRADIOLeft %W"
  bind FglRadioButton <Escape>     "fglXX %W %K"
  bind FglRadioButton <Control-r>  "fglX7 %W"
  bind FglRadioButton <Control-c>  "fglX6 %W Control-c"
  bind FglRadioButton <Any-Enter>  { }
  bind FglRadioButton <Any-Leave>  { }

  bind FglCheckButton <KeyPress>  "fglXX %W %K"
  bind FglCheckButton <Control-KeyPress>      "fglXX %W Control-%K"
  bind FglCheckButton <Down>      "fglXX %W %K"
  bind FglCheckButton <Up>        "fglXX %W %K"
  bind FglCheckButton <Return>    "fglXX %W %K"
  bind FglCheckButton <space>     "fglCHECKSelect %W"
  bind FglCheckButton <1>         "fglCHECKMouseFocus %W"
  bind FglCheckButton <FocusOut>  "fglCHECKFocusOut %W"
  bind FglCheckButton <Tab>       "fglXX %W %K"
  bind FglCheckButton <Right>     "fglXX %W Tab"
  bind FglCheckButton <Left>      "fglCHECKAskFocus %W;fglXX %W %K"
  bind FglCheckButton <Escape>    "fglXX %W %K"
  bind FglCheckButton <Control-r> "fglX7 %W"
  bind FglCheckButton <Control-c> "fglX6 %W Control-c"
}

proc fglTaskRes { } {
  global keymap bindClass tkOrgScrollbars tkOrgButtons watchDelay \
         fglUseOob

  if { [set intr [fglRes key.interrupt]] != "Control-c" } {
    set keymap(Control-c) ""
    foreach i $bindClass {
      bind $i       <$intr>  "fglX6 %W Control-c"
      bind $i       <Control-c>  { }
    }
  }
  set end 0
  for { set i 0 } { ! $end  } { incr i } {
    if ![fglRes key.${i}.translate trans] {
      if { $i } break
    } {
      set keymap([lindex $trans 0]) [lindex $trans 1]
    }
  }
  if { [set dcl [fglRes key.doubleClick.left]] != "KEY_accept" \
    || [fglRes key.click.right] != "F36" } {
      set cr  "[fglRes key.click.right]"
      foreach i $bindClass {
        bind $i <Double-1>  "fglXX %W $dcl"
        if { [string range $cr 0 0] != "@" } {
          bind $i <3>         "fglXX %W $cr"
        } {
          bind $i <3>         "[string range $cr 1 end]"
        }
      }
  }
  set tkOrgScrollbars "[expr [fglRes mswindow.scrollbar] == 0]"
  set tkOrgButtons    "[expr [fglRes mswindow.button] == 0]"
  set fglUseOob        [fglRes useOOB.interrupt]
  set watchDelay       [fglRes watch.delay]
  if { [set nbf [fglRes key.add_function]] != 12 } {
    foreach c $bindClass {
      for {set i 1} {$i<=12} {incr i} {
        bind $c <Shift-F${i}> "fglXX %W F[expr $i+$nbf]"
      }
      for {set i 1} {$i<=12} {incr i} {
        bind $c <Control-F${i}> "fglXX %W F[expr $i+2*$nbf]"
      }
    }
  }
  if { [set filename [fglRes config.file]] != "" } { 
    global fglConfigFile
    set fglConfigFile "[fglSearchConfigFileName $filename]"
    catch { option readfile $fglConfigFile interactive }
  }
  if { [fglRes key.radiocheck.invokeexit] != "" } {
    bind FglCheckButton <[fglRes key.radiocheck.invokeexit]> "fglCHECKSelect %W;fglXX %W Tab"
    bind FglRadioButton <[fglRes key.radiocheck.invokeexit]> "fglRADIOSelect %W;fglXX %W Tab"
  }
}

#############################font measurement################################

proc fglSetFont { } {
  global config dx dy dyl fglDyButtonKey fglY0 fglX0 fglWtkClient fglFont
  global fglFontFamilyButton
  set root .
#  puts stderr
  entry .e \
    -class FglEntry \
    -width 10
  set fglFont [lindex [.e configure -font] 4]
  if { [catch { listbox .l -borderwidth 0 -height $10 }]} {
    listbox .l \
      -class FglListbox \
      -geometry "10x10"
  }
  set dx [expr [winfo reqwidth .e] / 10 ]
  set dy [expr [winfo reqheight .e] + $config(entryPadY) ]
  set dyl [ expr [winfo reqheight .l] / 10]
  destroy .e
  destroy .l
  button .b -class FglButtonMenu
  button .bk -class FglButtonKey
  set fglDyButtonKey 0
  if { $fglWtkClient } {
    .b configure -font "Small Fonts-Bold-9"
    if {[winfo reqheight .b]<$dy} {
      set start 11
      set ff "${fglFontFamilyButton}-Bold-%d"
    } {
      set start 9
      set ff "Small Fonts-Bold-%d"
    }
  } {
    set ff "-adobe-${fglFontFamilyButton}-bold-r-*-%d-*"
    set start 1
  }
  for {set i $start} {$i<30} {incr i} {
    set font [format $ff $i]
    if { ![catch {.b configure -font $font } msg ] } {
      if {[winfo reqheight .b]>=$dy} {
#        puts stderr "#buttonFont :$font"
        .bk configure -font $font
        option add *FglButtonKey.font $font 100
        option add *FglButtonMenu.font $font 100
        option add *FglButtonMenuV.font $font 100
        option add *FglButtonMenuX.font $font 100
        option add *FglMenuName.font $font 100
        break
      }
    } {
#      puts stderr "#fglSetFont:$msg"
    }
  }
  set fglDyButtonKey  [winfo reqheight .bk]
  set fglDyButtonMenu [winfo reqheight .b]
  destroy .b .bk
  set fglY0 [expr $config(formPadY) + $fglDyButtonMenu - $dy + $config(entryPadY) ]
  set fglX0 $config(formPadX)
}

proc fglRedraw { id {readfile 1 }} {
  global fglConfigFile dpyChannel
  if {$readfile} {
    catch { option readfile $fglConfigFile interactive }
  }
  fglSetFont
  fglTaskConfigure
  set id $dpyChannel
  fgl_TaskClose 1
#fgl_TaskOpen
  fglSend $id redraw $id
}

proc fglChooseFont { root } {
  global dpyChannel fglFont
  if { [catch "choosefont $root {} -init \"$fglFont\"" f ]} {
#    puts stderr "#fglChooseFont:$f"
    set f [choosefont $root]
  }
  if {$f=="" || $f=="0" } return
  if { $f=="Lucida Console-Normal-11" } { set f "Lucida Console-Normal-10" }
  option add *font $f interactive
  set fglFont $f
  fglRedraw $dpyChannel 0
}
proc fglShowConnections { id } {
  global fglWtkClient
  if $fglWtkClient {
    if [ catch "dconn_insertdisplay $id" ] { catch {dconn_insertdisplay} }
  }
}
proc fglReportFont { root } {
  global fglWtkClient
  if $fglWtkClient {
    global dpyChannel
    if {[catch {fglwtk_ReportFont -id $dpyChannel -reportArray fglReport \
                 -root $root} msg]} {
      global errorInfo
      puts stderr "#fglwtk_ReportFont:$msg\n$errorInfo"
    }
  }
}
proc fglHardCopy { root } {
  global fglWtkClient
  if $fglWtkClient {
    global dpyChannel
    if {[catch {fglwtk_HardCopy -id $dpyChannel -reportArray fglReport \
                 -root $root -title [wm title [winfo toplevel $root]]} msg]} {
      global errorInfo
      puts stderr "#fglwtk_HardCopy:$msg\n$errorInfo"
    }
  }
}
proc fglPrintSetup { root } {
  global fglWtkClient
  if $fglWtkClient {
    global dpyChannel
    if {[catch {fglwtk_PrintSetup -id $dpyChannel -reportArray fglReport \
                -root $root} msg]} {
      global errorInfo
      puts stderr "#fglwtk_PrintSetup:$msg\n$errorInfo"
    }
  }
}
proc fglCreateSysMenu { t id} {
  global fglReport
  set m [winfo toplevel $t].sysMENU
  if {[winfo exists $m]} { return }
  menu $m
  set m_prn $m.mp
  menu $m_prn
  $m add separator
  $m add command -label "FGL-&Tasks" -command "fglShowConnections $id"
  $m add command -label "&Fonts" -command "fglChooseFont $t"
  $m add cascade -label "&Printing..." -menu $m_prn
  $m add command -label "&SaveConfig" -command "fglCbSaveConfig"
  $m_prn add command -label "&PrinterFont(User):$fglReport(font)..." -command "fglReportFont $t"
  $m_prn add check   -label "use &Automatic Font" -variable fglReport(use_default_font)
  $m_prn add separator
  $m_prn add command -label "&HardCopy" -command "fglHardCopy $t"
  $m_prn add check   -label "use HardCopy &Rectangles"  -variable fglReport(use_hardcopy_rects)
  $m_prn add check   -label "use Pixel Hardcopy"  -variable fglReport(pixel_hardcopy)
  $m_prn add separator
  $m_prn add command -label "PrintSetup:$fglReport(printer)..." -command "fglPrintSetup $t"
  trace variable fglReport(font) w "fglSetMenuVar $m_prn 0"
  trace variable fglReport(printer) w "fglSetMenuVar $m_prn 6"
  bind $m_prn <Destroy> "\
    trace vdelete fglReport(printer) w \"fglSetMenuVar $m_prn 6\"; \
    trace vdelete fglReport(font) w \"fglSetMenuVar $m_prn 0\" ;"
}
#    puts stderr \"#vdelete $m_prn\";
proc fglSetMenuVar { menu pos var el ops } {
#  puts stderr "#fglSetMenuVar $menu $pos $var $el $ops"
  global $var
  set name "$var\($el\)"
  if {[winfo exists $menu]==0} {
    puts stderr "#trace vdelete $name $ops \"fglSetMenuVar $menu $pos\""
    trace vdelete $name $ops "fglSetMenuVar $menu $pos"
    return
  }
  if {[catch {$menu entryconfigure $pos -label} list]} {
    puts stderr "#fglSetMenuVar: $menu,$list";
    return
  }
  set label  [lindex $list 4]
  set begin [string range $label 0 [string first : $label]]
  $menu entryconfigure $pos -label "$begin[set $name]..."
}

proc fglTaskFree { t id } {
  fglArrayFree dMenu $t
  fglArrayFree wnd   $t
  fglArrayFree _task  $id
  fglArrayFree dFrame $t
  catch {fglUserFree}
  global _task
  catch {unset _task(id,$_task(taskId,$id))}
}

proc fglTestLine { y { c "Black" } } {
  global wnd topWnd config
  set w $topWnd.textLine$y
  if { ![winfo exists $w] } {
    entry $w \
      -class FglMessage \
      -width $wnd($topWnd,dimX) \
      -textvariable wnd($topWnd,textvar,$y)
    place $w \
      -x [fglFormX 0] \
      -y [fglFormY $y]
  }
  return $w
}

proc fglFormY { y } {
  global dy fglY0
  return [expr $fglY0 + $dy * $y ]
}

proc fglFormLY { y } {
  global dyl
  return [expr $dyl * $y ]
}

proc fglFormX { x } {
  global dx fglX0
  return [expr $fglX0 + $dx * $x ]
}

proc fglKeyPad { ascii keysym {keycode 0}} {
  global keymap
  if { $keysym == "??" && [info exists keymap($keycode)] } {
    return $keymap($keycode)
  } elseif { [string match \[0-9\] $ascii ] } {
    return $ascii
  } {
    return $keysym
  }
}

##################
#  bind $w <Control-a>         {
#  		  if { $modePrt == "ow" } {
#                    set modePrt "in"
#                  } else {
#                    set modePrt "ow"
##                  }
#                }
#  bind $w <Control-x>         {
#                  set pos [%W index insert]
#                  %W delete $pos $pos
##                }
#  bind $w <Control-d>         {
#                  set pos [%W index insert]
#                  %W delete $pos end
#                }
#

#@proc fglBindEdit2 { w but1 t } {
#@  global dpyChannel
#@  set id $dpyChannel
#@  bind $w <Any-KeyPress>          "entryAnyKey %W $id $t %A %K"
#@  bind $w <Left>                  "entryCu %W $id %K -1"
#@  bind $w <Right>                 "entryCu %W $id %K +1"
#@  bind $w <Return>                "fglSendKey $id %K"
#@  bind $w <Tab>                   "fglSendKey $id %K"
#@  bind $w <Escape>                "fglSendKey $id %K"
#@  bind $w <Delete>                "fglSendKey $id %K"
#@  bind $w <BackSpace>             "fglSendKey $id %K"
#@
#@#  bind $w <Up>                    "fglSendKey $id %K"
#@#  bind $w <Down>                  "fglSendKey $id %K"
#@#  bind $w <Next>                  "fglSendKey $id %K"
#@#  bind $w <Prior>                 "fglSendKey $id %K"
#@
#@  bind $w <Control-KeyPress>      "fglSendKey $id Control-%K"
#@  bind $w <Mod1-KeyPress>         "fglSendKey $id Alt-%K"
#@  bind $w <Mod1-Control-KeyPress> "fglSendKey $id Alt-Control-%K"
#@  bind $w <Control-r>             "fglSend $id redraw $id"
#@  bind $w <Mod2-Key-Tab>          "puts stderr \"Alt Tab $w $id\""
#@  bind $w <1>                     "$but1"
#@  bind $w <Double-1>              "fglSendKey $id KEY_accept"
#@  for {set i 1} {$i<=12} {incr i} {
#@    bind $w <Shift-F${i}>          "fglSendKey $id F[expr $i+12]"
#@  }
#@  for {set i 1} {$i<=12} {incr i} {
#@    bind $w <Control-F${i}>          "fglSendKey $id F[expr $i+24]"
#@  }
#@  global fglWtkClient
#@  if {$fglWtkClient} {
#@    catch {
#@     bind $w <ClientMessage> "fglCbTaskAbort $id %W"
#@    }
#@  }
#@}

set modePrt "ow"

proc entryCu { W id K count } {
  global currEntry; set currEntry $W
  set pos [$W index insert]
  if { $count < 0 } {
    if { $pos == 0 } {
      fglSendKey $id $K
      return
    }
  } elseif { $count > 0 } {
    if { $pos >= [$W index end] } {
      $W insert insert " "
    }
    if { $pos >= [lindex [$W configure -width] 4] } {
      fglSendKey $id $K
      return
    }
  }
  incr pos $count
  $W icursor $pos
}

proc entryAnyKey { W id t A K } {
  global currEntry; set currEntry $W
  global modePrt
  set width [lindex [$W configure -width] 4]
  set pos [$W index insert]
  if { $A == "" || $pos == $width } {
    fglSendKey $id "$K"
    return
  }
  if { $pos == 0 && $t == "N" } {
    $W delete $pos end
  }
  if { $modePrt == "ow" } {
    $W delete $pos $pos
  }
  $W insert insert $A
  if { $modePrt == "in" && [$W index end] > $width } {
    $W delete $width end
  }
  if { [$W index insert] >= $width } {
    fglFlush $id
  }
}

proc fglFlush { id } {
  global currEntry
  if { "$currEntry" == "" } { return }
  set w $currEntry
  set currEntry ""
  fglSend $id buffer "[$w index insert] [$w get]"
}

if $fglWtkClient {
    set defcursor IDC_ARROW
  } {
    set defcursor top_left_arrow
}
set watchDelay 50

proc fglTimeOut { id } {
  global _task
  if { ! [info exists _task($id,Timer)] || $_task($id,Timer) == 0 } return
  set top $_task($id,TopLevel)
  puts stderr "TimeOut $top configure -cursor watch"
  $top configure  -cursor watch
#  update
}

proc fglTimeOff { id } {
  global _task defcursor
  if { ! [info exists _task($id,Timer)]} return
  set _task($id,Timer) 0
  set top $_task($id,TopLevel)
  puts stderr "TimeOff $top configure -cursor $defcursor"
  $top configure -cursor $defcursor
#  update
}

proc fglTimeOn { id } {
  global _task watchDelay
  if { ! [info exists _task($id,Timer)]} return
  set _task($id,Timer) 1
  after $watchDelay "fglTimeOut $id"
  puts stderr "TimeOn"
}

proc fglSend { id t v } {
  global fglWtkClient
  fglFlush $id
#  puts stderr "#fglSend $id $t $v"
#  fglTimeOn $id
  if { $fglWtkClient } {
#    puts stderr "$t $v"
    catch { wtklogappend "#fglSend $id $t $v" }
    catch {$id puts "$t $v"}
  } {
# Don't comment next line 
    puts stdout "$id $t $v"
    flush stdout
  }
}

proc fglSendIntr { id k } {
  global fglWtkClient fglUseOob
#puts stderr "#interrupt"
  if { ! $fglUseOob }  {
     fglSendKey $id $k
   } elseif { $fglWtkClient } {
      catch { wtklogappend "#fglSendIntr $id $k" }
      catch {$id putsnnloob "\x7f" }
    } {
      puts stdout "$id interrupt $k"
      flush stdout
  }
}

proc fglSendKey { id k } {
  global keymap
  if { ! [info exists keymap($k)] } {
    set keymap($k) $k
  }
  if { $keymap($k)!="" } {
    fglSend $id key $keymap($k)
  }
}

proc fglButtonCommand { id k } {
  if { "$k" == "KEY_interrupt"  } {
    fglSendIntr $id $k
  } {
    fglSendKey $id $k
  }
}

proc w2id { w } {
  global task2id
  if { $w == "??" } { return "" }
  set t [winfo toplevel $w]
  while { $w != $t } {
    if { ! [catch { set id $task2id($w) } ] } {
      return $id
    }
    set w [winfo parent $w]
  }
#  puts stderr "#no window found"
  return ""
}

proc w2n { w } {
  return [string range [winfo name $w] 1 end]
}

proc fglXX { w v } {
  if { [set id [w2id $w]] == "" } return
  fglSendKey $id $v
}

proc fglXBuff { w v } {
  if { [set id [w2id $w]] == "" } return
  fglSend $id buffer "$v"
}

proc fglX6 { w v } {
  if { [set id [w2id $w]] == "" } return
  fglSendIntr $id $v
}

proc fglX7 { w } {
  if { [set id [w2id $w]] == "" } return
#  fglSend $id redraw $id
#  fglRedraw $id
}

proc fglX1 { w x } {
#puts stderr "#fglX1 $w $x"
  if { [set id [w2id $w]] == "" } return
  set name [winfo name $w]; set n [string range $name 1 end]
  fglCbEntryAnyButton $id $n $x $w
}

proc fglX2 { w x y } {
  if { [set id [w2id $w]] == "" } return
  set name [winfo name $w]; set n [string range $name 1 end]
  fglCbListBut1 $id [winfo parent $w] $n $w $x $y
}

proc fglX22 { w } {
  fglListxview $w [winfo parent $w] 0
}

proc fglX3 { w } {
  if { [set id [w2id $w]] == "" } return
  fglCbMenuCommand $id $w [w2n $w]
}

proc fglX4 { w } {
  if { [set id [w2id $w]] == "" } return
catch {   fglCbMenuEnter $id $w [w2n $w]  }
}

proc fglX5 { w } {
  if { [set id [w2id $w]] == "" } return
  fglCbSbButtonRelease $id $w
}

proc fglArrayFree { aname pat } {
  global $aname
  if { ! [info exists $aname] } {
    return
  }
  foreach elt [array names $aname] {
    if { [string match "$pat\[.,\]*" $elt] } {
      unset [set aname]($elt)
    }
  }
}

###################################################################################
# callback function

proc fglCbListBut1 { sockid topWnd n w x y } {
  global dx
  fglSend $sockid nextfield "${n}_[ $w nearest $y ] \
    [ expr [fglListxview $w $topWnd] + $x / $dx ]"
}

proc fglCbSaveConfig2 { fileConfig id } {
  set nbl 0
  set font_line -1
  global fglReport
  foreach i [array names fglReport] {
    set report_lines($i) -1
  }
  if { ! [catch {set f [open $fileConfig "r+"]}] } {
    while { [gets $f line] >= 0 } {
      if { [regexp {^\*font:.*} $line whole ] } {
        set font_line $nbl
      } elseif { [regexp {.*\*report_([a-z_]*).*} $line whole opt] } {
#        puts stderr "line $line report_lines $opt"
        set report_lines($opt) $nbl
      }
      set lines($nbl) "$line"
      incr nbl
    }
    close $f
  }
  if { $font_line == -1 } {
    set font_line $nbl
    incr nbl
  }
  set font [option get . font "" ]
  set lines($font_line) "*font: $font"
  foreach i [array names fglReport] {
    if { [set l $report_lines($i)]== -1 } {
      set l $nbl
      incr nbl
    }
    if {$fglReport($i)==""} {
      set lines($l) ""
    } else {
      set lines($l) "*report_$i: $fglReport($i)"
    }
  }
#  puts stderr "#nbl is $nbl, [array names lines]"
  set f [open $fileConfig "w"]
  for {set i 0} { $i < $nbl } {incr i} {
    if {$lines($i)==""} { continue }
    puts $f "$lines($i)"
#    puts stderr "#fileConfig:$i $lines($i)"
  }
  close $f
}

proc fglCbSaveConfig { } {
  global dpyChannel
  global fglConfigFile
  if {[catch "fglCbSaveConfig2 $fglConfigFile $dpyChannel" msg]} {
    global errorInfo
    puts stderr "#fglCbSaveConfig2:$msg\n$errorInfo"
  }
}

proc fglCbMenuScroll { sockid w m flag } {
  global dMenu
  tk_butEnter $w
  if { $flag == -1 } {
    set page [expr $dMenu($m,currpage) -1]
    set ix   [expr [llength $dMenu($m,page,$page)] - 2]
  } else {
    set page [expr $dMenu($m,currpage) +1]
    set ix   1
  }
  fglSend $sockid menuenter  [lindex $dMenu($m,page,$page) $ix]
  fglCbMenuEnter $sockid $w [lindex $dMenu($m,page,$page) $ix]
}

proc fglCbTaskAbort { id w } {
  global fglWtkClient
  if {$fglWtkClient} {
    set toplevel [winfo toplevel $w]
    if {[msgbox $toplevel "Cannot be stopped !" [wm title $toplevel] ok]=="yes" } {
#      sockClose $id
      wtkfglsockClose $id
    } else {
      myFocus $w
    }
  }
}

proc fglCbEntryAnyButton { id n x w } {
#  puts stderr "#fglCbEntryAnyButton $id $n $x $w"
#  puts stderr "#state of $w is [lindex [$w config -state] 4]"
  if {[lindex [$w config -state] 4] == "disabled"} {
    return
  }
  $w icursor "@$x"
  fglSend $id nextfield "$n [ $w index insert ]"
}

proc fglCbMenuCommand {sockid w menuid } {
  global dMenu lastMenuId
  set tw [winfo parent $w]
  set lastMenuId $menuid
  if {[lindex [$w config -state] 4] != "disabled"} {
    if { ! [info exists dMenu($tw,nextoption) ] || $dMenu($tw,nextoption) == "nextoption" } {
      fglSend $sockid nextoption $menuid
    } else {
       fglSendKey $sockid "$dMenu($tw,nextoption)"
    }
  }
}

proc fglCbMenuEnter { id w mfId } {
  global dMenu taskRoot topWnd
#  puts stderr "#fglCbMenuEnter $id $w $mfId"
  if { ![winfo exists $taskRoot] || [winfo toplevel $taskRoot] != [winfo toplevel $w]} { return }
  set p [winfo parent $w]
  if { $topWnd == [winfo parent $p] && [lindex [$w config -state] 4] != "disabled"} {
    fglMenuComment $dMenu($p,menuComment,$mfId) $dMenu($p,menuCommentLine)
  }
}

## ??
proc fglX11dExit { procid } {
  puts stdout "DAEMON_EXIT $procid"
  flush stdout
  after 500 exit
}

# internal end
####################################################################################
# interface begin

proc fgl_Retrieve { v {taskId 0}} {
  global $v dpyChannel _task
   
  if { ! $taskId || [catch "set _task(id,$taskId)" id]} {
    set id $dpyChannel
  }
#  puts stderr "#fglSend $id retrieve \"[set $v]\""
  if { [ catch { fglSend $id retrieve "[set $v]" } msg ] } {
    fglSend $id error retrieve 
#    puts stderr "#retrieve error: $msg"
  }
}

set lastMenuId -1

proc fglMenuCreate { p n y } {
  global dMenu
  set dMenu($p,menuCommentLine) [expr $y + 1]
}

proc fgl_MenuCreateV { n y } {
  global yahoo taskRoot config _task dpyChannel fglDyButtonKey
  set yahoo 0
  fgl_ButtonFrameCreate
  set yahoo 1
  set p $taskRoot.bf
  set e $p.m_name
  label $e \
    -class FglMenuName \
    -text $n 
  place $e \
    -x [ expr $config(buttonPadX) ] \
    -y [ expr ( $fglDyButtonKey + 2 ) * $_task($dpyChannel,NumButtons) ]
  set _task($dpyChannel,NumButtons) 2
  fglMenuCreate $p $n $y
}

proc fglButtonCreate { w class t {cmd ""} } {
  if { [string range $t 0 0] == "@" } {
    set l "[fglBMPName [string range $t 1 end]]"
    set type "[lindex $l 0]"
    set t "[lindex $l 1]"
  } {
    set type text
  }
  if { $type == "text" } {
    button $w -class $class -text "$t"
  } else {
    button $w -class $class -bitmap "$t"
  }
  if { $cmd != "" && $cmd != " " } {
    $w config -command "$cmd"
  }
}

proc fglButtonConfig { w t {args ""} } {
  if { [string range $t 0 0] == "@" } {
    set l "[fglBMPName [string range $t 1 end]]"
    set type "[lindex $l 0]"
    set t "[lindex $l 1]"
  } {
    set type text
  }
#  puts stderr "$w config -$type \"$t\" $args"
  if { $type == "text" } {
    $w config -text "$t"
  } else {
    $w config -bitmap "$t"
  }
  if { [string compare $args "" ] } {
    eval "$w config $args"
  }
}

proc fgl_MenuCreateH { n y } {
  global dy dx topWnd wnd fglX0 config _task
  global dpyChannel _task
  global dMenu
  set id $dpyChannel
  set mfId 0
  set p $topWnd.menu
  set b $p.m$mfId
  catch {destroy $p }
  catch {fglArrayFree dMenu $p }
  frame $p \
    -class FglMenuFrame \
    -height [ expr $dy * 2 ] \
    -width  [ expr $dx * $wnd($topWnd,dimX) ]
#    -y [fglFormY $y]
  place $p \
    -y [expr $config(formPadY) + ( $dy * $y) ] \
    -x $fglX0
  set dMenu($p,display) 0
  set dMenu($p,nbt) 0
  set dMenu($p,sockid) $id
  set dMenu($p,actived) 1
  set dMenu($p,nextoption) nextoption
  set dMenu($p,timer) 0
  fglButtonCreate $b FglMenuNameH $n
#  button $b \
#    -class FglButtonMenu \
#    -text $n
  bind $b <1>         { }
  bind $b <Any-Enter> { }
  bind $b <Any-Leave> { }
  set dMenu($p,max) [expr $wnd($topWnd,dimX)*$dx - $fglX0 - [winfo reqwidth $b]]
  pack $b -side left

  set dMenu($p,menuCommentLine) [expr $y + 1]
  set dMenu($p,menuComment,$mfId) ""
  set dMenu($p,name,$mfId) $p.m$mfId
  set dMenu($p,id,$n) $mfId
  set dMenu($p,text,$mfId) $n
  set _task($id,menuStyle) 0
}

proc fglMenuFieldCreate { p n mfId comment class } {
  global dpyChannel dMenu
  set id $dpyChannel
  set b $p.m$mfId
  fglButtonCreate $b $class $n "fglCbMenuCommand $id $b $mfId"
#  button $b \
#    -class $class \
#    -text $n \
#    -command "fglCbMenuCommand $id $b $mfId"
  set dMenu($p,menuComment,$mfId) $comment
  set dMenu($p,name,$mfId) $p.m$mfId
  set dMenu($p,mfId,$n) $mfId
  set dMenu($p,text,$mfId) $n
#  puts stderr "#fglMenuFieldCreate $p $n $mfId $comment $class"
  fglTBConfigure \
    "$n {}" \
    "fglCbMenuCommand $id $b $mfId" \
    normal \
    "fglCbMenuEnter   $id $b $mfId"
  return $b
}

proc fgl_MenuFieldCreateV { n mfId {comment {} } } {
  global taskRoot _task dpyChannel config fglDyButtonKey
  set p $taskRoot.bf
  set b [fglMenuFieldCreate $p "$n" $mfId $comment FglButtonMenuV]
  place $b \
    -x [ expr $config(buttonPadX) ] \
    -y [ expr ( $fglDyButtonKey + 2 ) * $_task($dpyChannel,NumButtons) ]
  set _task($dpyChannel,NumButtons) [ expr $_task($dpyChannel,NumButtons) + 1 ]
}

proc fgl_MenuFieldCreateH { n mfId {comment {} } } {
  global topWnd dMenu
  set p $topWnd.menu
  set b [fglMenuFieldCreate $p "$n" $mfId $comment FglButtonMenu]
  set dMenu($p,$mfId,width) [winfo reqwidth $b]
  lappend dMenu($p,lid) $mfId
  incr dMenu($p,nbt)
  set dMenu($p,menuComment,$mfId) $comment
  set dMenu($p,name,$mfId) $p.m$mfId
  set dMenu($p,id,$n) $mfId
  set dMenu($p,text,$mfId) $n
}

######################################################################
# Cut menu page per page
######################################################################
proc fglMenuPrepare { m } {
  global dMenu config

###########################
# Control length of items #
###########################
  foreach id $dMenu($m,lid) {
    if { ( $dMenu($m,max) < $dMenu($m,$id,width) ) } {
      fgl_Error -1 "Item too big to fit into menu windows"
      return 0
    }
  }

########################
# Create scroll button #
########################
  button $m.mleft \
    -class FglButtonMenu \
    -text " ... "
  bind $m.mleft <ButtonRelease-1> "%W config -relief $config(menuButtonRelief);fglCbMenuScroll $dMenu($m,sockid) %W $m -1"
  set dMenu($m,left,width) [winfo reqwidth $m.mleft]

  button $m.mright \
    -class FglButtonMenu \
    -text " ... "
  bind $m.mright <ButtonRelease-1> "%W config -relief $config(menuButtonRelief);fglCbMenuScroll $dMenu($m,sockid) %W $m 1"
  set dMenu($m,right,width) [winfo reqwidth $m.mright]

  set lg 0
  set nb 1
  set page 1

#####################
# Cut page per page #
#####################
  foreach id $dMenu($m,lid) {
    set currlg [expr $lg + $dMenu($m,$id,width)]
    if { ( $currlg > $dMenu($m,max) || $nb != $dMenu($m,nbt) ) \
        && [expr $currlg + $dMenu($m,right,width)] > $dMenu($m,max) } {
      if { $nb != $dMenu($m,nbt) } {
        lappend dMenu($m,page,$page) right
        incr page
        lappend dMenu($m,page,$page) left
        set currlg [expr $dMenu($m,left,width) + $dMenu($m,$id,width)]
      }
    }
    set dMenu($m,$id,page)   $page
    lappend dMenu($m,page,$page) $id
    set lg $currlg
    incr nb
  }

  set dMenu($m,currpage) 0
  set dMenu($m,nbpage) $page
  return 1
}

######################################################################
# Display current menu
######################################################################
proc fglMenuDisplay { m id } {
  global dMenu
  if { ! [info exists dMenu($m,display) ] } {
    return
  }
  if { ! $dMenu($m,display) } {
    if { ! [fglMenuPrepare $m] } {
      return
    }
    set dMenu($m,display) 1
  }
  if { ! [info exists dMenu($m,$id,page) ] } {
    return
  }
  set page $dMenu($m,$id,page)
  if { $page != $dMenu($m,currpage) } {
    if { $dMenu($m,currpage) } {
      set forget ""
      foreach id $dMenu($m,page,$dMenu($m,currpage)) {
        set forget "$forget $m.m$id"
      }
      eval "pack forget $forget"
    }
    set add ""
    foreach id $dMenu($m,page,$page) {
      set add "$add $m.m$id"
    }
    eval "pack $add -side left"
    set dMenu($m,currpage) $page
  }
}

proc fgl_MenuDestroyV { } {
  global taskRoot
  fgl_ButtonFrameDestroy
  fglArrayFree dMenu $taskRoot.bf
}

proc fgl_MenuDestroyH { } {
  global topWnd
  catch {destroy $topWnd.menu}
  fglArrayFree dMenu $topWnd.menu
}

proc fglMenuEnable { p a c } {
  global config
  if { $a } { set state "normal" } { set state "disabled" }
  foreach i [ winfo children $p ] {
    if { [string match "FglButtonMenu*" [winfo class $i]] } {
      if { [lindex [ $i configure -state ] 4] != $state } {
        $i configure -state $state
      }
      if { $state=="normal" && [lindex [ $i configure -relief ] 4] != $config(menuButtonRelief) } {
        $i configure -relief $config(menuButtonRelief)
      }
    }
  }
  if { $c != -1 && $state=="disabled"} {
# any incative Menu has an selected MenuField
    $p.m$c configure -relief sunken
  }
}

proc fgl_MenuEnableV { a { c 1 } } {
  global taskRoot
  set p $taskRoot.bf
  fglMenuEnable $p $a $c
  if { $c >= 0 } {
    fgl_MenuFocusV $c
  } {
    myFocus  $p.m_name
  }
}

#proc fgl_MenuEnableH { a { c 1 } } {
#  global topWnd dMenu
#  set p $topWnd.menu
## next lines used by customers
#  if { ! $dMenu($p,actived) } {
#    return
#  }
#  fglMenuEnable $p $a $c
#  if { $a && $c != -1 } {
#    catch { fgl_MenuFocusH $c }
#  }
#}
proc fgl_MenuEnableH { a { c 1 } } {
  global topWnd dMenu
  set p $topWnd.menu
#  puts stderr "#dMenu($p,actived) $dMenu($p,actived)"
  if { ! [info exist dMenu($p,actived)] || ! $dMenu($p,actived) } {
    return
  }
  if { $a } {
    set dMenu($p,state) "normal"
    fglMenuEnable $p $a $c
  } {
    set dMenu($p,state) "disabled"
    if { ! $dMenu($p,timer) } {
      set dMenu($p,timer) 1
      after [fglRes menu.timer] \
          "if { \[info exists dMenu($p,state) \] && \$dMenu($p,state) == \"disabled\" } { \
               fglMenuEnable $p $a $c };set dMenu($p,timer) 0"
    }
  }
  if { $a && $c != -1 } {
    catch { fgl_MenuFocusH $c }
  }
#  puts stderr "#End dMenu($p,actived) $dMenu($p,actived)"
}

#next function for compatibility with old
proc fgl_MenuEnable { a { c 1 } } {
  global lastMenuId
#  return
  if { $a == "Active" } {
    set a 1
  } {
    set a 0
  }
#  puts stderr "#fgl_MenuEnableH $a $c"
  fgl_MenuEnableH $a -1
  if { $a } {
    fgl_MenuFocusH $lastMenuId
  }
}

proc fglMenuFocus { p id } {
  global dMenu lastMenuId
#puts stderr "fglMenuFocus $p $id"
  foreach i [ winfo children $p ] {
    if { [string match "FglButtonMenu*" [winfo class $i]] } {
      if { [lindex [$i configure -state] 4] != "normal" } {
        $i configure -state normal
      }
    }
  }
  fglMenuComment $dMenu($p,menuComment,$id) $dMenu($p,menuCommentLine)
  if { ![catch {$p.m$id configure -state active}] } {
    set lastMenuId $id
  }
#  puts stderr "myFocus $p.m$id" 
  catch {myFocus "$p.m$id" }
}

proc fgl_MenuFocusV { id } {
  global taskRoot
  set p $taskRoot.bf
  fglMenuFocus $p $id
}

proc fgl_MenuFocusH { id } {
  global topWnd
  set p $topWnd.menu
# next line for overwrite display on menu
  raise $p
  fglMenuDisplay $p $id
  fglMenuFocus $p $id
}


proc fgl_ButtonSet { k l } {
  global taskRoot
  set w $taskRoot.bf.b$k
  if { $l == "" || $l == " " } {
    $w configure -state disabled
  } else {
    $w configure -state  normal
  }
 fglButtonConfig $w $l
# $w configure -text $l
}

proc fgl_ButtonCreate { k l } {
  global taskRoot fglDyButtonKey
  global _task config dx dpyChannel
  set buttonFrame $taskRoot.bf
  set w $buttonFrame.b$k
  if { [ winfo exists $w ] } { return }
  set tbId [ fglTBConfigure "\"$l\" $k" "fglButtonCommand $dpyChannel $k" normal ]
  if { $tbId!=0 && [fglRes toolBar.$tbId.hideButton hide] && $hide=="1" } return
  fglButtonCreate $w FglButtonKey "-$l" "fglButtonCommand $dpyChannel $k"
  fglButtonConfig $w "$l"
#  button $w \
#    -class FglButtonKey \
#    -text $l \
#    -command "fglButtonCommand $dpyChannel $k"
  if { $l == "" || $l == " " } {
    $w configure -state disabled
  } else {
    $w configure -state  normal
  }
  place $w \
    -x [ expr $config(buttonPadX) ] \
    -y [ expr ( $fglDyButtonKey + 2 ) * $_task($dpyChannel,NumButtons) ]
  set _task($dpyChannel,NumButtons) [ expr $_task($dpyChannel,NumButtons) + 1 ]
#  puts stderr "#fgl_ButtonCreate: focus [focus]"
  if { $_task($dpyChannel,menuStyle) && [focus] =="none" } {
    myFocus $w
  }
}

proc fgl_ButtonFrameDestroy { } {
  global taskRoot _task dpyChannel
  set buttonFrame $taskRoot.bf
  foreach w [ winfo children $buttonFrame ] { destroy $w }
  set _task($dpyChannel,NumButtons) 0
  fglTBReset
}

proc fgl_ButtonFrameCreate {  } {
  global _task dpyChannel
  global yahoo
  if {$yahoo==1} {
    set yahoo 0
    return
  }
  fgl_ButtonFrameDestroy
  set _task($dpyChannel,NumButtons) 0.5
}

proc fgl_ButtonFrameSeparate {  } {
  global _task dpyChannel
  set _task($dpyChannel,NumButtons) [expr $_task($dpyChannel,NumButtons) + 0.5]
}

proc fgl_EntryCreate { n C y x l c S } {
  global topWnd
  global dx dy $topWnd.fields
#  config -foreground $config($c)
  set $topWnd.fields($n) " "
  set w $topWnd.e${n}
  if {[winfo exists $w]} {
    $w co -textvar $topWnd.fields($n) -width $l
  } {
    entry $w -class FglEntry -textvar $topWnd.fields($n) -width $l
  }
  place $w \
    -x [fglFormX $x] \
    -y [fglFormY $y]
  return $w
}

proc fgl_EntryConfigure { n s c r h u b } {
  global topWnd
  if { $s } {
    fglPutAttr $topWnd.e${n} FglEntryActive $b $c $r $h $u $b
  } else {
    fglPutAttr $topWnd.e${n} FglEntryNormal $b $c $r $h $u $b
  }
}

proc fgl_QueryCreate { n y } {
  global config queryLine
  global dpyChannel
  set queryLine $y
  set w [fglTestLine $y]
  $w configure \
    -background $config(bgEntryActive) \
    -state normal
}

proc fgl_QuerySet { v x } {
  global queryLine
  fgl_Comment $queryLine $v
  set w [fglTestLine $queryLine]
  $w icursor $x
  myFocus $w
}

proc fgl_QueryDestroy { } {
  global config queryLine
  set w [fglTestLine $queryLine]
  destroy $w
}

proc fgl_ListCreate { n y x l d } {
  global topWnd wnd dyl dx
  global dpyChannel
  global $topWnd.fields
  set w $topWnd.l${n}
  if { $wnd($topWnd,dimX) + $x < $l } {
    set len [expr $wnd($topWnd,dimX) - $x ]
  } else {
    set len $l
  }
  set $topWnd.fields($n,width) $len
  if { [catch { listbox $w -relief sunken -borderwidth 1 -width ${len} -height ${d} }]} {
    listbox $w \
      -class FglListbox \
      -geometry "${len}x${d}"
  }
  for { set i 0 } { $i < $d } { incr i } {
    $w insert $i {           }
  }
  place $w \
    -x [fglFormX $x] \
    -y [fglFormY $y]

  fglListxview $w $topWnd 0

  if { $len != $l } {
    set sbX "${w}_sbX"
    $w configure -xscrollcommand "$sbX set"
    scrollbar $sbX \
      -class FglScrollbar \
      -command ";fglListxview $w $topWnd " \
      -orient  horizontal
    bind $sbX  <ButtonRelease-1>    { }
    bind $sbX  <ButtonRelease-3>    { }
    place $sbX \
      -x [fglFormX $x] \
      -y [expr [fglFormY $y] + [fglFormLY $d] ] \
      -height [expr $dx * 1.8 ] \
      -width  [expr $dx * $len]

  }
}

proc fgl_ListSet { n i i1 v } {
  global topWnd
  set w $topWnd.l${n}
#  $w delete $i $i1
#  eval "$w insert $i $v"
 eval "$w replace $i $v"
}

proc fgl_ListScroll { n i } {
  global topWnd
  set w $topWnd.l${n}
  if { $i < 0 } {
    for {  } { $i < 0 } { incr i } {
      $w delete 0
      $w insert end ""
    }
  } {
    for {  } { $i > 0 } { incr i -1 } {
      $w delete end
      $w insert 0 {     }
    }
  }
}

proc fgl_ListSelect { n y h } {
  global topWnd
  if { $h } { $topWnd.l${n} highlight $y }
}

proc fgl_ListFocus { n col } {
  global topWnd
  global $topWnd.fields
  set w $topWnd.l${n}
  catch { $w entrypos $col }
  set l0 [fglListxview $w $topWnd]
  set l  [set $topWnd.fields($n,width)]
  if { [expr $col > ( $l0 + $l )] } {
    set val [expr $col - $l ]
  } else {
    if { [expr $col < $l0] } {
      set val $col
    } else {
      set val $l0
    }
  }
  fglListxview $w $topWnd $val
  myFocus $w
}

proc fglListxview { w topWnd {col -1} } {
  global $topWnd.fields
  if { $col == -1 } {
    return [set $topWnd.fields($w,xview)]
  }
  set $topWnd.fields($w,xview) $col
  $w xview $col
}

proc fgl_EntrySelect { n h } {
  global topWnd
  set w $topWnd.e${n}
  ${w} highlight $h
}

proc fgl_EntryState { n s t A } {
  global config topWnd
  set e $topWnd.e${n}
  if { $s } {
      $e configure \
        -state normal
    if { ! $A } {
      $e configure -background $config(bgEntryActive)
    }
#    switch "$t" \
#     "N" - "C" { fglBindEdit2 $e "$but1" "$t" } \
#      default { fglBindEdit  $e "$but1" }
  } else {
#@    $e view 0
    if { $A } {
      $e configure \
        -state disabled
    } {
      $e configure \
        -state disabled \
        -background $config(bgEntryNormal)
    }
  }
}

proc fgl_ListState { n s } {
  global config topWnd
  global dpyChannel
  set l $topWnd.l${n}
  if { $s } {
    $l configure -background $config(bgListboxActive)
  } {
    $l configure -background $config(bgListboxNormal)
    fglListxview $l $topWnd 0
    $l highlight -1
  }
}

proc fgl_EntrySet { n v } {
  global topWnd
  global $topWnd.fields
  set w $topWnd.e${n}
  set l0 [$w index @0]
#  raise $w
  set $topWnd.fields($n) $v
  if { $l0 } { $w view $l0 }
}

set currEntry ""

proc fgl_EntryFocus { n c } {
  global topWnd
  global dpyChannel
  set w $topWnd.e${n}
  set l0 [$w index @0]
  $w configure -state normal
  $w icursor $c
  myFocus $w
  set l [lindex [$w configure -width] 4]
  if { [expr $c > ( $l0 + $l )] } {
    $w view [expr $c - $l ]
  } else {
    if { [expr $c < $l0] } {
      $w view $c
    } else {
      $w view $l0
    }
  }
}

set config(lineSize) 3
set config(padLine) 0.3


proc fgl_LineV { y x l {c White} {add 0} } {
  global dx dy topWnd config
  set w $topWnd.lineV${x}_$y
  catch { destroy $w }
  frame $w\
    -class FglLine \
    -height [expr $dy * $l + $config(lineSize) ]  \
    -width $config(lineSize)
  place $w \
    -x [expr [fglFormX $x] + $config(lineSize)] \
    -y [expr [fglFormY [expr $y + $config(padLine)]] \
          + $add * $config(lineSize) ]
  if { $c != "White" } {
    $w configure -background $config($c)
  }
}

proc fgl_LineH { y x l {c White} {add 0} } {
  global dx dy topWnd config
  set w $topWnd.lineH${x}_$y
  catch { destroy $w }
  frame $w \
    -class FglLine \
    -width [expr $dx * $l + $config(lineSize) ]  \
    -height $config(lineSize)
  place $w \
    -x [expr [fglFormX $x] + ( 1 + $add ) * $config(lineSize)] \
    -y [fglFormY [expr $y + $config(padLine)]]
  if { $c != "White" } {
    $w configure -background $config($c)
  }
}

proc fgl_Box { y x nl nc {c White} } {
   if { ! $nl && ! $nc } {
     fgl_LineV $y $x 1 $c
   } elseif { ! $nl } {
     fgl_LineH $y $x $nc $c
   } elseif { ! $nc } {
     fgl_LineV $y $x $nl $c
   } else {
     fgl_LineV $y $x $nl $c
     fgl_LineH $y $x $nc $c
     fgl_LineV $y [expr $x + $nc] $nl $c
     fgl_LineH [expr $y + $nl] $x $nc $c
   }
}

proc fgl_Label { y x t c r { h 0 } { u 0 }  { b 0 } } {
  global topWnd wnd
  set l $topWnd.ey${y}_$x
  if {![winfo exists $l]} {
    label $l  -class FglLabel 
  }
  $l configure -text "$t"
  place $l \
    -x [fglFormX $x] \
    -y [fglFormY $y]
  fglPutAttr $l FglLabel 1 $c $r $h $u $b
}

proc fgl_Error { y m {c "Black"} {r 0} {h 0} {u 0} {b 0}} {
  global  taskRoot wnd
  set w $taskRoot.labelError
  catch { destroy $w }
  label $w \
    -class FglError \
    -width $wnd($taskRoot,X) \
    -text "${m}"
  if { $y == -1 } {
   set y [expr ($wnd($taskRoot,Y) - 1 )]
  }
  place $w \
    -x [fglFormX 0] \
    -y [ expr [fglFormY $y] + ([fglRes toolBar.enabled]?  [fglRes toolBar.sizeY]:0 )]
  if { $r == 0 || $h == 1 || $u == 1 || $b == 1 } {
    fglPutAttr $w FglError $b $c $r $h $u $b
  }
  fgl_Bell
}

proc fgl_ErrorDestroy {  } {
  global taskRoot
  catch { destroy $taskRoot.labelError }
}

proc fgl_Comment { y m } {
  global topWnd wnd
  set w [fglTestLine $y]
  set wnd($topWnd,textvar,$y) "$m"
}

proc fgl_Message { y m { c "Black" } {r 0} {h 0} {u 0} {b 0} } {
  global topWnd wnd
  set w [fglTestLine $y]
  raise $w
  fglPutAttr $w FglMessage $b $c $r $h $u $b
  set wnd($topWnd,textvar,$y) "$m"
}

proc fglMenuComment { m y } {
  global topWnd wnd
#puts stderr "fglMenuComment $topWnd $m $y"
  fglTestLine $y
  set wnd($topWnd,textvar,$y) "$m"
}

proc fglMenuComment2 { w m y } {
  global wnd
  set wnd($w,textvar,$y) "$m"
}

proc fgl_FormDisplay { name { y 0 }} {
  global topWnd taskRoot
  set y0 [fglFormY $y]
  foreach w [ winfo children $topWnd ] {
    set y [lindex [place info $w ] 3]
    if { ! [string match *.menu $w ] && [expr $y >= $y0] } {
      destroy $w
    }
  }
  myFocus $taskRoot
}

proc fglWindowHeight { sy } {
  global dy fglWindowAddY
  return [ expr $dy * $sy + $fglWindowAddY + 2]
}

proc fglWindowWidth { sx } {
  global dx fglWindowAddX
  return [ expr $dx * $sx + $fglWindowAddX + 2]
}

proc fgl_ScreenSize { sy sx } {
  fglResSet screen.size.x $sx
  fglResSet screen.size.y $sy
}

proc fgl_WindowOpen { n sy sx py px border { c "Black" } } {
  global wnd topWnd config taskRoot
  global dx dy
#  fglTaskConfigure
  set useToolBar [fglRes toolBar.enabled]
  if { ( $sx + 2 * $border ) > $wnd($taskRoot,X) } {
    set sx [ expr ( $wnd($taskRoot,X) - (2 * $border) ) ]
  }
  set topWnd $taskRoot.$n
  set wnd($topWnd,title) ""
  set wnd($topWnd,dimX) $sx
  set wnd($topWnd,dimY) $sy
  set wnd($topWnd,border) $border
  set wnd($topWnd,bg) [set bg $config(bgcolor$c)]

  catch {destroy $topWnd }
  set b [ expr $border ? $config(WindowBorder) : 0 ]
  if { $n == "screen" } {
    frame $topWnd \
      -class FglFrame \
      -height [ expr [fglWindowHeight $sy] + 2] \
      -width  [ expr [fglWindowWidth  $sx] + 2] \
      -relief raised \
      -borderwidth  1 \
      -background $bg
  } {
    if { $b } {
    frame $topWnd \
      -class FglFrame \
      -height [ expr [fglWindowHeight $sy] + 2 * $b] \
      -width  [ expr [fglWindowWidth  $sx] + 2 * $b] \
      -background $bg
    } {
    frame $topWnd \
      -class FglFrame \
      -height [ expr [fglWindowHeight $sy] + 2 * $b] \
      -width  [ expr [fglWindowWidth  $sx] + 2 * $b] \
      -relief flat \
      -borderwidth  0 \
      -background $bg
    }
    if { [fglRes window.move] } {
      fglMoveBind $topWnd $topWnd
    }
  }
  place $topWnd \
    -x [ expr $dx *  $px - $b ]  \
    -y [ expr $dy *  $py - $b + ($useToolBar ? [fglRes toolBar.sizeY]:0 ) ]
}

proc fgl_WindowSetOptions { m c f e } {
}

proc fglWindowClose2 { n } {
  global $n.fields
  destroy $n
  catch { unset $n.fields  }
}

proc fgl_WindowClose { n } {
  global taskRoot
  set w $taskRoot.$n
  global $w.fields
  catch { destroy $w }
  catch { unset $w.fields  }
  myFocus $taskRoot
}

proc fgl_WindowSelect { n } {
  global topWnd taskRoot wnd
  raise [ set topWnd "$taskRoot.$n"]
#  wm title .$taskRoot $wnd($topWnd,title)
#  fgl_SetTitle $wnd($topWnd,title)
}

proc fgl_WindowClear { n } {
  global taskRoot
  set w $taskRoot.$n
  foreach c [ winfo children $w ] { destroy $c }
}

proc fglChangeTextLine { y x t } {
  global topWnd wnd
  set old $wnd($topWnd,textvar,$y)
  set line [format "%-*s" $x $old]
  set line "[string range $line 0 [expr $x - 1] ]$t"
  if { "$t" == "" } {
    set wnd($topWnd,textvar,$y) "$line"
  } else {
    set wnd($topWnd,textvar,$y) "$line[string range $old [string length $line] \
			                                 [string length $old]]"
  }
}

proc fgl_DisplayAt { y x t c {r 0} {h 0} {u 0 } {blink 0}} {
  global topWnd wnd

#patch1
#  if { $y == -1 } {
#    fglWindowTitle $x $t $c $r $h $u $blink
#    return
#  }
#end patch1

  if { [winfo exists $topWnd.textLine$y] } {
    fglChangeTextLine $y $x "$t"
    return
  }

  if { $wnd($topWnd,border) } {
    if { [expr $x + [string length "$t"]] > $wnd($topWnd,dimX) } {
      set t [string range "$t" 0 [expr $wnd($topWnd,dimX) - $x - 1]]
    }
  }

  set w ${topWnd}.xy${y}_$x;

  if { [winfo exists $w] } {
    if {[string compare " [lindex [$w config -text] 4]" "$t"] } {
      $w config -text "$t"
    }
    raise $w
  } else {
    label $w \
      -text "$t" 
    place $w \
      -x [fglFormX $x] \
      -y [fglFormY $y]
  }
  fglPutAttr $w FglLabel 1 $c $r $h $u $blink
  if { [set id [w2id $w]] == "" } return
  set oldSock $id
  update
  sockCheck $oldSock
}

proc fgl_ClearToEol { y x } {
  global topWnd
  if { [winfo exists $topWnd.textLine$y] } {
    fglChangeTextLine $y $x ""
    return
  }
  foreach c [winfo child $topWnd] {
    if { [string match "${topWnd}.\[ex\]y${y}_*" $c] } {
      regexp "${topWnd}.\[ex\]y${y}_\(\[0-9\]+\)" $c dummy val
      if { $val >= $x } {
         destroy $c
      } else {
         set t [lindex [$c config -text] 4]
         set l [string length $t]
         if { [expr $val + [string length $t]] > $x } {
           set t [string range $t 0 [expr $x - $val - 1]]
           $c config -text $t
         }
      }
    }
  }
}

proc fgl_Bell { } {
 global dpyChannel
 catch { messagebeep }
#puts -nonewline stderr "\007"
}

proc fgl_SetTitle { t } {
  global topWnd wnd taskRoot
#  set wnd($topWnd,title) $t
  wm title [winfo toplevel $taskRoot] "$t"
  set wnd($taskRoot,title) "$t"
  global fglWtkClient
  if {$fglWtkClient} {
    catch dconn_actualizedisplay
  }
}

proc fgl_Exit { } {
}

proc connect { u1 u2 protocoll script } {
#  global dpyChannel fglScriptVersion
  global nbSocket dpyChannel
#  puts stderr "$dpyChannel server hostnotfound 2.60 connections: $nbSocket"
#  puts stdout "$dpyChannel server hostnotfound 2.60 connections: $nbSocket"
#  fglSend $dpyChannel version $fglScriptVersion
}

set nbSocket 0
set lastSockOpen -1
proc sockOpen { id } {
  global _task dpyChannel nbSocket lastSockOpen
  set _task($id,TaskRoot) ""
  set _task($id,TopLevel) .
  set _task($id,TopWnd) ""
  set _task($id,Timer) 0
  set _task($id,menuStyle) 1
#  puts stderr "sockOpen $id"; flush stderr
#  set _task($id,Focus) ""
  set lastSockOpen $id
  sockSelect $id
  puts stdout "$id ok"
  flush stdout
  incr nbSocket
}

proc asklic { type } {
  global nbSocket dpyChannel
#  puts stderr "$dpyChannel ok $nbSocket"
  puts stdout "$dpyChannel ok $nbSocket"
  flush stdout
}

proc sockCheck { id } {
  global fglWtkClient 
  if { $fglWtkClient } {
    catch {wtkcheckcurrsock $id}
  } else {
    sockSelect $id
  }
}

proc sockSelect { id } {
  global _task dpyChannel
  global taskRoot topWnd wnd

  set _task($dpyChannel,TaskRoot) $taskRoot
  set _task($dpyChannel,TopWnd) $topWnd
  set dpyChannel $id
#  puts stderr "sockSelect $id"; flush stderr

  if {[info exists _task($id,TaskRoot)]} {
    set taskRoot $_task($id,TaskRoot)
    set topWnd   $_task($id,TopWnd)
  } {
    set taskRoot ""
    set topWnd   ""
  }
}

proc sockClose { id } {
##puts stderr "sockClose $id"
  global _task nbSocket
  catch { unset _task($id,TaskRoot) }
  catch { unset _task($id,TopWnd) }
  incr nbSocket -1
  fgl_TaskClose
}

proc fglDef { name defvalue } {
  global _task dpyChannel
  if { ![info exists _task($dpyChannel,RES,$name)] } {
    set _task($dpyChannel,RES,$name) $defvalue
  }
}

proc fglSetResDefaults { } {
  global config
  fglDef button.width         15
  fglDef menu.timer           100
  fglDef toolBar.enabled      0
  fglDef toolBar.sizeY        26
  fglDef toolBar.sizeX        27
  fglDef toolBar.gapX         2
  fglDef toolBar.gapY         1
  fglDef toolBar.sep          0.3
  fglDef toolBar.dir          "toolbars"
  fglDef bubbleHelp.enabled   1
  fglDef bubbleHelp.color     $config(bgBubble)
  fglDef bubbleHelp.offtime   1000
  fglDef bubbleHelp.disptime  3000
  fglDef screen.size.x        80
  fglDef screen.size.y        25
  fglDef key.interrupt        Control-c
  fglDef key.doubleClick.left KEY_accept
  fglDef key.click.right      F36
  fglDef screen.x   	      incr
  fglDef screen.y   	      incr
  fglDef screen.incrx  	      3
  fglDef screen.incry  	      2
  fglDef window.move  	      0
  fglDef mswindow.scrollbar   1
  fglDef mswindow.button      1
  fglDef watch.delay          100
  fglDef screen.withwm        1
  fglDef useOOB.interrupt     1
  fglDef key.add_function     12
  fglDef config.file          {}
  fglDef key.radiocheck.invokeexit "Return"
}

proc fglRes { name {varname "" }} {
  global _task dpyChannel
  if {$varname == "" } {
    return $_task($dpyChannel,RES,$name)
  }
  upvar $varname v
  if [catch { set _task($dpyChannel,RES,$name) } v] {
    set v ""
#puts stderr "#fglRes 0:$name $v"
    return 0
  }
#puts stderr "#fglRes 1:$name $v"
  return 1
}

proc fglResSet { name value } {
  global _task dpyChannel
  set _task($dpyChannel,RES,$name) $value
}

proc fgl_TaskConfigure { taskId name value } {
#  puts stderr "#fgl_TaskConfigure $taskId $name $value"
  fglResSet $name $value
}

proc fglTaskPos { gi s t } {
  if { $t == "x" } {
    global dx; set size screenwidth; set pos rootx; set nbp $dx;
    incr s 5
  } {
    global dy; set size screenheight; set pos rooty; set nbp $dy
    incr s 20
  }
  if { [fglRes screen.$t] == "center" } {
    set p [expr ([winfo $size $gi] - $s)/2]
  } elseif { [fglRes screen.$t] == "incr" } {
    set max 0
    foreach g [winfo child .] {
      if { [string match "FglFrameGroup*" [winfo class $g]] } {
        if { $max < [winfo $pos $g] } { set max [winfo $pos $g] }
      }
    }
    set p [expr $max + [fglRes screen.incr$t]*$nbp]
  } else {
    set p [expr [fglRes screen.$t]*$nbp]
  }
  if { [expr $p + $s] > [winfo $size $gi] } {
    set p [expr [winfo $size $gi] - $s - 10]
  }
  if { $p < 2 } { set p 2 }
#  puts stderr "incr $t $nbp [fglRes screen.incr$t] [expr [fglRes screen.incr$t]*$nbp]"
  return $p
}

proc fgl_TaskOpen { taskId grpId progName } {
  global dpyChannel fglWtkClient wxb wnd _task defcursor
  global config fglX0 userDelay 
#  puts stderr "fgl_TaskOpen $taskId $grpId $progName" ; flush stderr
  fglSetResDefaults
  set useToolBar [fglRes toolBar.enabled]
  fglTaskRes
  option add *FglButtonKey.width [fglRes button.width] userDefault
  option add *FglButtonMenuV.width [fglRes button.width] userDefault
  option add *FglButtonMenuName.width [fglRes button.width] userDefault
  set id $dpyChannel
  set _task(id,$taskId) $id
  set _task(taskId,$id) $taskId
  button .b -class FglButtonKey
  set wxb [ expr 2 * $config(buttonPadX) + [winfo reqwidth .b] ]
  destroy .b
  set wx [expr [fglWindowWidth  [fglRes screen.size.x]]+2 ]
  set wy [expr [fglWindowHeight [fglRes screen.size.y]]+2 ]
  set w .$grpId.$taskId
  if { ![winfo exist .$grpId] } {
    set sx [expr $wx + $wxb]
    set sy [expr $wy + ( $useToolBar ? [fglRes toolBar.sizeY] : 0 ) ]
    toplevel .$grpId \
      -class FglFrameGroup \
      -width  $sx \
      -height $sy
# alt-f4 disabled in X11
    if { ! $fglWtkClient } {
      wm protocol .$grpId WM_DELETE_WINDOW { }
    }
    set px [fglTaskPos .$grpId $sx x]
    set py [fglTaskPos .$grpId $sy y]
    wm geometry .$grpId =${sx}x$sy+$px+$py
    if { ! [fglRes screen.withwm] } {
      wm overrideredirect .$grpId 1
      .$grpId config -cursor $defcursor
    }
    if {$fglWtkClient} {
      fglCreateSysMenu .$grpId $dpyChannel
      catch {
        bind .$grpId <ClientMessage> "fglCbTaskAbort $dpyChannel %W"
      }
    } else {
      bind .$grpId <Configure> "fglResize $grpId $dpyChannel $sx $sy"
      wm minsize .$grpId 200 200
    }
  }
  frame $w \
    -class FglFrameTask \
    -width  [expr $wx + $wxb] \
    -height [expr $wy + ( $useToolBar ? [fglRes toolBar.sizeY] : 0 ) ]
  place $w \
    -y 0 \
    -x 0
  if $useToolBar {
    fglTBCreate $id $w $wx
  }
  myFocus $w
  global task2id
  set task2id($w) $id
#  fglBindFocusIn $w $id
  set _task($dpyChannel,Focus) $w
  set buttonFrame $w.bf
  frame $buttonFrame \
    -class FglKeyFrame \
    -width  $wxb \
    -height [expr $wy + ( $useToolBar ? [fglRes toolBar.sizeY] : 0 ) ]
  place $buttonFrame \
    -x $wx \
    -y 0
#  incr wx $wxb

  global taskRoot topWnd dpyChannel _task
  set _task($id,TopLevel) .$grpId
  set _task($id,TaskRoot) $w
  set _task($id,TopWnd) $w
  set taskRoot $w
  set wnd($taskRoot,X) [fglRes screen.size.x]
  set wnd($taskRoot,Y) [fglRes screen.size.y]
  set wnd($taskRoot,totX) -1
  set topWnd $w
  set dpyChannel $id
  fgl_SetTitle $progName

  set userDelay 1
  fgl_WindowOpen "screen" [fglRes screen.size.y] [fglRes screen.size.x] 0 0 0
  set oldSock $id
  update
  sockCheck $oldSock
  raise .$grpId
}

proc fglTaskConfigure { } {
  global taskRoot config wnd
  button .b -class FglButtonKey
  set wxb [ expr 2 * $config(buttonPadX) + [winfo reqwidth .b] ]
  destroy .b
  set wx [expr [fglWindowWidth  $wnd($taskRoot,X)] + 2 ]
  set wy [expr [fglWindowHeight $wnd($taskRoot,Y)] + 2 ]
  set buttonFrame $taskRoot.bf
  place $buttonFrame \
    -width  $wxb \
    -height $wy
  place $buttonFrame -x $wx -y 0
  incr wx $wxb
  wm geometry [winfo toplevel $taskRoot] ${wx}x${wy}
}

##########################
#  focus

proc myFocus { w } {
#puts stderr "#myFocus $w [focus]"
  global dpyChannel _task grp2Focus
#  puts stderr "#myFocus w=$w dpyChannel=$dpyChannel"
  set foc [focus]
#puts stderr "foc $foc [winfo toplevel $foc] [winfo toplevel $w]"
  if { $foc=="none" || $foc == "." || [winfo toplevel $foc]==[winfo toplevel $w] } {
# if you use scroll option in field form and not wtk 1.40, you must comment 2 next lines
#    global taskRoot
#    catch "focus $taskRoot"
    if [catch "focus $w" ] return
#puts stderr "#focus $w"
  }
#  fglTimeOff $dpyChannel
  set _task($dpyChannel,Focus) $w
  set grp2Focus([winfo toplevel $w]) $w
}

proc myFocusSet { id } {
  global _task taskRoot
  if { [info exists _task($id,Focus)] && [winfo exists $_task($id,Focus)] } {
    focus $_task($id,Focus)
  } else {
    focus [winfo toplevel $taskRoot]
  }
}

proc fglFocusIn { w } {
  global grp2Focus
  if [catch "set grp2Focus($w)" foc] {
#    puts stderr "fglFocusIn1:$foc"
    return
  }
#  puts stderr "#fglFocusIn2:Focus to $foc"
  catch "focus $foc"
}

proc fglFocusOut { w } {
  global grp2Focus
#  puts stderr "#fglFocusOut1 $w"
  set grp2Focus([winfo toplevel $w]) $w
}

proc fglFocusOutEntry { e } {
# puts stderr "#fglFocusOutEntry $e {focus is [focus]}"
# if you use scroll option in field form and wtk 1.40, you must comment next line
  $e view 0
  $e select clear
  fglFocusOut $e
}

proc fglDestroy { w } {
  if { [focus]!=$w } return
  global grp2Focus
  set grp2Focus([winfo toplevel $w]) none
#  puts stderr "fglDestroy $w"
}
#########################


proc fgl_TaskClose { { inRedraw 0 } } {
  global taskRoot dpyChannel
  set t $taskRoot
  if {![winfo exists $t]} {
    return
  }
  fglTaskFree $t $dpyChannel
  foreach w [winfo children $t] { fglWindowClose2 $w }
  set p [winfo parent $t]
  catch {destroy $p.scX}
  catch {destroy $p.scY}
  catch {destroy $p.scY}
  destroy $t
  if { !$inRedraw && ([set ch [winfo children $p]]=="" || $ch == "$p.sysMENU") } {
    destroy $p
  }
}

proc fgl_TaskSelect { } {
  global taskRoot dpyChannel wnd
  myFocusSet $dpyChannel
  if [ info exists wnd($taskRoot,title) ] {
    fgl_SetTitle $wnd($taskRoot,title)
  }
  fglTopRaise $taskRoot
}

proc fgl_TermSelect { } {
  if { [winfo exists .t ] } { raise . }
}

proc fglTopRaise { t } {
  raise [winfo toplevel $t]
}

proc fgl_ShellMode { } {
  catch { bind all <Any-Button> "" }
}

proc fgl_WindowMode { } {
  global taskRoot
  fglTopRaise $taskRoot
}

proc fglCbArrayView { w y } {
  scan [$w get] "%d %d %d %d" t v f l
  set yMax [ expr $t - $v + 1]
  if { $y > $yMax  } {
    set y $yMax
  } elseif { $y < 0 } {
    set y 0
  }
  $w set $t $v $y [expr $y + $v - 1]
  global fglWtkClient tkOrgScrollbars
  if {$fglWtkClient && !$tkOrgScrollbars} {
    fglX5 $w
  }
}

proc fglCbSbButtonRelease { sockid w } {
  fglSend $sockid arraygoto [lindex [$w get] 2]
}

proc fgl_ScrollBarConfigure { n t v f } {
  global topWnd
  $topWnd.$n set $t [expr $v + 1] $f [expr $f + $v - 1]
}

proc fgl_ScrollBarCreate { n y x d t } {
  global topWnd config dx dy dyl
  global dpyChannel wnd

  if { $wnd($topWnd,dimX) < $x } {
    set x $wnd($topWnd,dimX)
  }
  set w $topWnd.$n
  if { $t=="listbox" } {
    set yy $dyl
    set y0 2
  } {
    set yy $dy
    set y0 -$config(entryPadY)
  }
  scrollbar $w \
    -class FglScrollbar \
    -command ";fglCbArrayView $w"
  place $w \
    -x [expr [fglFormX $x] - 2] \
    -y [fglFormY $y] \
    -height [expr $yy * $d + $y0 ] \
    -width  [expr $dx * 1.8]
}

proc fgl_ScrollBarDestroy { n } {
  global topWnd
  destroy $topWnd.$n
}

catch {source locals.tcl}

proc fglPdmDestroy { } {
  global taskRoot
  catch {destroy $taskRoot.pdm}
}

proc fgl_Pdm { m } {
  global taskRoot
  global config
  global dpyChannel
  set p $taskRoot.pdm
  catch {destroy $p}

  frame $p  \
    -relief ridge \
    -borderwidth 2
  place $p -x 400 -y 20

  set w ${p}.l

  listbox $w \
    -background $config(bgEntryActive)
  set i 0
  set l 10
  foreach item $m {
    incr i
    if { [ string length $item ] > $l } { set l [string length $item ] }
    $w insert end " $item "
  }
  incr l 3
  $w configure -geometry "${l}x${i}"
  bind $w  <Any-Enter>  { %W select from [ %W nearest %y ] }
  bind $w  <Any-Motion> { %W select from [ %W nearest %y ] }
  bind $w  <1>          "fglSend $dpyChannel nextoption \[ %W nearest %y \]; fglPdmDestroy "
  bind $w  <Control-KeyPress> "fglSendKey $dpyChannel Control-%K; fglPdmDestroy"
  myFocus $w

  pack append $p \
    $w  { top fill expand }
}

proc fgl_PromptCreate { text y le  {dc "Black"} {dr 0} {dh 0} {du 0} {db 0} \
                       {pc "Black"} {pr 0} {ph 0} {pu 0} {pb 0} } {
  global topWnd config wnd dy
  set w $topWnd.p
  set ll [ string length $text ]
  set b  [expr $wnd($topWnd,border)*$config(WindowBorder) ]
  set b 0
  set sy 1
  set sx $wnd($topWnd,dimX)
  frame $w \
    -class FglPromptFrame \
    -height [ fglWindowHeight $sy ] \
    -width  [ fglWindowWidth  $sx ]
  place $w \
    -x 0 \
    -y [expr $dy * $y]
  set t $topWnd
  set topWnd $w
  fgl_Label 0 0 $text $dc $dr $dh $du $db
  set n promptEntry_0_0
  fgl_EntryCreate    $n fglPrompt 0 [expr $ll+0] $le "Black" ""
  fgl_EntryState     $n 1 "" 0
  fgl_EntryConfigure $n 1 $pc $pr $ph $pu $pb
#  fgl_EntryFocus  promptEntry_0_0 0
  set topWnd $t
}

proc fgl_PromptSet { v c } {
  global topWnd
  set t $topWnd
  set topWnd $topWnd.p
  set n promptEntry_0_0
  fgl_EntrySet   $n $v
  fgl_EntryFocus $n $c
  set topWnd $t
}

proc fgl_PromptDestroy { } {
  global topWnd taskRoot
  destroy $topWnd.p
  myFocus $taskRoot
}
###########################

proc fglButtonName { n } {
  global  topWnd
  return $topWnd.e${n}
}

proc fglButtonKeyFocusOut { w } {
  if { [lindex [$w configure -state] 4]!="disabled" } {
      $w configure -state normal
  }
}

set tk_myBUTTON ""
proc fglBUTTONButtonPress { w } {
  global tk_myBUTTON
  set tk_myBUTTON $w
  tk_butDown $w
}

proc fglBUTTONButtonRelease { w } {
  global tk_myBUTTON
  if { $w == $tk_myBUTTON } {
    $w invoke
    tk_butUp $w
  }
  set tk_myBUTTON ""
}

proc fgl_BUTTONCreate { n C y x l c  S } {
  global dx dpyChannel
  set w [fglButtonName $n]
  if { $S == "" } { set S "dummy" }
  fglButtonCreate $w FglButtonKey "$S" "fglSendKey $dpyChannel $S"
  $w configure -state disabled 
  if { [string range $S 0 0] !="@" } {
    $w configure -width [expr $l + 2 ]
  }
#  button $w \
#    -class FglButtonKey \
#    -width [expr $l + 2 ] \
#    -text $S \
#    -state disabled \
#    -command "fglSendKey $dpyChannel $S"
  place $w \
    -x [fglFormX [expr $x - 1] ] \
    -y [fglFormY $y] \
    -width [expr ($l + 1) * $dx]
  bind $w <ButtonPress-1>   "fglBUTTONButtonPress %W"
  bind $w <ButtonRelease-1> "fglBUTTONButtonRelease %W"
  bind $w <Any-Enter> { }
  bind $w <Any-Leave> { }
}
proc fgl_BUTTONConfigure { n s c {r 0 } {h 0} {u 0} {b 0} } {
  global topWnd
  set w $topWnd.e${n}
  if { $s } {
    $w configure -state normal
  } else {
    $w configure -state disabled
  }
}
proc fgl_BUTTONFocus { n h } {
  global topWnd
  set w $topWnd.e${n}
  myFocus $w
}
proc fgl_BUTTONSelect { n h } {
}
proc fgl_BUTTONState { n { s "Normal" } e h } {
  global topWnd
  set w $topWnd.e${n}
  if { $s } {
    $w configure -state normal
  } else {
    $w configure -state disabled
  }
}
proc fgl_BUTTONSet { n v } {
  if { $v=="*" } {
     [fglButtonName $n] configure \
       -state disabled
    return
  } elseif { $v=="!" } {
     [fglButtonName $n] configure \
       -state normal
    return
  } elseif { $v=="" } { set state "disabled" } { set state "normal" }
  fglButtonConfig [fglButtonName $n] "$v" -state $state
#  [fglButtonName $n] configure \
#     -text $v \
#     -state $state
}

################
# Move procedure

proc fglMoveBegin { w x y } {
  global $w.move taskRoot
  set $w.move(x)    [expr $x - [winfo x $taskRoot]]
  set $w.move(y)    [expr $y - [winfo y $taskRoot]]
  set $w.move(newx) [winfo x $w]
  set $w.move(newy) [winfo y $w]
#  puts stderr "set $w.move(x)    [expr $x - [winfo x $taskRoot]]"
#  puts stderr "set $w.move(y)    [expr $y - [winfo y $taskRoot]]"
}

proc fglMovePlace { w x y } {
  global $w.move
  if { ! [info exists $w.move] } {
    fglMoveBegin $w $x $y
  }
  set $w.move(newx) [expr [set $w.move(newx)] + $x - [set $w.move(x)]]
  set $w.move(newy) [expr [set $w.move(newy)] + $y - [set $w.move(y)]]
  place $w -x [set $w.move(newx)] \
           -y [set $w.move(newy)]
  set $w.move(x)  $x
  set $w.move(y)  $y
}

proc fglMoveStop { w } {
  global $w.move
  set x [set $w.move(newx)]
  set y [set $w.move(newy)]
  catch {unset $w.move}
}

proc fglMoveBind { m lw} {
  foreach w $lw {
    bind $w <1>               "fglMoveBegin $m %X %Y"
    bind $w <B1-Motion>       "fglMovePlace $m %X %Y"
    bind $w <ButtonRelease-1> "fglMoveStop $m"
  }
}

#############
# BMP buttons

proc fglBMPName { name } {
  global fglWtkClient

  if $fglWtkClient { set pre "" } { global fgldir; set pre $fgldir/ }
  foreach dir "[fglRes toolBar.dir] bmp" {
    if { ! [ string match "\/*" $name ] } {
      set path ${pre}$dir/$name
    } {
      set path $name
    }
    if { ! [catch {set f [open $path "r"]}] } {
      close $f
      break
    }
  }
  if $fglWtkClient { set pre "@" } { set pre "%" }
  if { ! [catch {set f [open $path "r"]}] } {
      close $f
      return "bitmap ${pre}$path"
  } {
      return "text $name"
  }
}

proc fgl_BMPCreate { n C y x l c  S } {

  global dpyChannel
  set w [fglButtonName $n]

  if { [llength $S] != 2 } {
    button $w -text "Bad config"
  } else {
    fglButtonCreate $w FglBMPKey "@[lindex $S 0]" \
		"fglSendKey $dpyChannel [lindex $S 1]"
    $w config -state "disabled"
  }
  place $w \
    -x [fglFormX [expr $x - 1] ] \
    -y [fglFormY $y]
  bind $w <ButtonPress-1>   "fglBUTTONButtonPress %W"
  bind $w <ButtonRelease-1> "fglBUTTONButtonRelease %W"
}

proc fgl_BMPConfigure { n s {c Black} { r 0 } {h 0} {u 0} {b 0} } {
  set w [fglButtonName $n]
  if { $c == "White" } {
  } else {
    $w configure -state "disabled"
  }
  if { $s } {
    $w configure -state normal
  } else {
    $w configure -state disabled
  }
}

proc fgl_BMPFocus { n h } {
  set w [fglButtonName $n]
  myFocus $w
}
proc fgl_BMPSelect { n h } {
}
proc fgl_BMPState { n { s "Normal" } e h } {
  set w [fglButtonName $n]
  if { $s } {
    $w configure -state normal
  } else {
    $w configure -state disabled
  }
}
proc fgl_BMPSet { n v } {
  set w [fglButtonName $n]
  if { $v=="" } {
    $w configure -state disabled
  } elseif { $v=="!" } {
    $w configure -state normal
  } else {
    fglButtonConfig $w "@$v" -state normal
  }
}

###############
# RADIO buttons

proc fglRADIOLeft { w } {
  set frm [winfo parent $w]
  fglRADIOAskFocus $frm
  fglXX $frm Left
}
proc fglRADIOFocusOut { w } {
  if { $w != [focus] && [lindex [$w config -state] 4] != "disabled" } then {
    $w configure -state normal
  }
}
proc fglRADIOMouseFocus { w } {
  if { [set state [lindex [$w configure -state] 4]]!="disabled" } {
    global dFrame
    set frm [winfo parent $w]
    set curr [lindex [winfo children $frm] $dFrame($frm,index)]
    if { [lindex [$curr configure -state] 4]=="active" || $dFrame($frm,class)=="key" } {
      fglRADIOSelect $w
    } else {
      fglRADIOAskFocus $frm
      set dFrame($frm,ask) 1
      set dFrame($frm,index) [lsearch -exact [winfo children $frm] $w]
      focus $w
   }
  }
}
proc fglRADIOAskFocus { frm } {
  global dFrame
  set id [w2id $frm]
  if { $dFrame($frm,input) } {
    set name [winfo name $frm]; set n [string range $name 1 end]
    fglSend $id nextfield "$n 0"
  }
}
proc fglRADIOSelect { w } {
  global dFrame
  set frm [winfo parent $w]
  if { [lindex [$w configure -state] 4]!="disabled" || $dFrame($frm,class)=="key" } {
    set dFrame($frm,index) [lsearch -exact [winfo children $frm] $w]
    $w select
    fglRADIOSend $frm
  }
}
proc fglRADIOSend { frm } {
  global dFrame
  fglRADIOAskFocus $frm
  if { $dFrame($frm,class) == "key" } {
    fglXX $frm [lindex $dFrame($frm,var) 0]
  } {
    set  val $dFrame($frm,var)
    for { set l 0 } { $l < [string length $val] } { incr l } {
      fglXX $frm [string index $val $l]
    }
  }
}
proc fglRADIODown { w } {
  global dFrame
  set frm [winfo parent $w]
  set i $dFrame($frm,index)
  if { [expr $i+1] < [llength [winfo children $frm]] } {
    incr i
    set w [lindex [winfo children $frm] $i]
    myFocus $w
    $w config -state active
    incr dFrame($frm,index) 
  } else {
    fglXX $frm Tab
  }
}
proc fglRADIOUp { w } {
  global dFrame
  set frm [winfo parent $w]
  set i $dFrame($frm,index)
  if { $i > 0 } {
    incr i -1
    set w [lindex [winfo children $frm] $i]
    myFocus $w
    $w config -state active
    incr dFrame($frm,index) -1
  } else {
    fglRADIOAskFocus $frm
    fglXX $frm Left
  }
}

proc fgl_RADIOCreate { n C y x l c S } {
  global dx dpyChannel topWnd dFrame
  set frm $topWnd.e${n}
  if { [llength $S] == 0 } {
    set S {0 ConfigError}
  }
  frame $frm \
    -class FglRadioFrame
  set ml 0
  set dFrame($frm,class) $C 
  for { set i 0 } { $i < [llength $S] } { incr i 2} {
    if { $ml < [string length [lindex $S $i]] } {
      set ml [string length [lindex $S $i]]
    }
  }
  for { set i 0 } { $i < [llength $S] } { incr i 2} {
    set val [lindex $S $i]
    for { set lp [string length $val] } { $lp < $ml } { incr lp } {
      set val "$val "
    }
    lappend dFrame($frm,val) $val
    set tex [lindex $S [expr $i+1]]
    set w $frm.radio_[set i]
    radiobutton $w \
      -class FglRadioButton \
      -width $l \
      -text $tex \
      -variable dFrame($frm,var)\
      -value $val\
      -anchor w\
      -state disabled
    pack $w -in $frm
  }
  place $frm \
    -x [fglFormX $x] \
    -y [fglFormY $y] \
    -width [expr ($l + 1) * $dx]
  set dFrame($frm,index) 0
  set dFrame($frm,ask)   0
  set dFrame($frm,input) 0
}
proc fgl_RADIOConfigure { n s c {r 0} {h 0} {u 0} {b 0}} {
  global topWnd
  set frm $topWnd.e${n}
  if { $s } {
    foreach w [winfo children $frm] {
      $w configure -state normal
    }
  } else {
    foreach w [winfo children $frm] {
      $w configure -state disabled
    }
  }
}
proc fgl_RADIOFocus { n h } {
  global topWnd dFrame
  set frm $topWnd.e${n}
  set w [lindex [winfo children $frm] $dFrame($frm,index)]
  set foc [focus]
  $w configure -state active
  myFocus $w
  if { $w == $foc && $dFrame($frm,ask) }  {
    set dFrame($frm,ask) 0
    fglRADIOSelect $w
  }
  set dFrame($frm,ask) 0
}
proc fgl_RADIOSelect { n h } {
}
proc fgl_RADIOState { n {s "normal"} e h } {
  global topWnd dFrame
  set frm $topWnd.e${n}
  set dFrame($frm,input) $s
  if { $s } {
    foreach w [winfo children $frm] {
      $w configure -state normal
    }
  } else {
    foreach w [winfo children $frm] {
      $w configure -state disabled
    }
  }
}

proc fgl_RADIOSet { n v } {
  global topWnd dFrame
  set frm $topWnd.e${n}
  if { $v=="*" } {
    foreach w [winfo children $frm] {
      $w configure -state disabled
    }
    return
  } elseif { $v=="!" } {
    foreach w [winfo children $frm] {
      $w configure -state normal
    }
    return
  }
  set i [lsearch -regexp $dFrame($frm,val) "^$v *\$"]
  set dFrame($frm,var) [lindex $dFrame($frm,val) $i ]
  if { $i == -1 } then {
    set i 0
  }
  set dFrame($frm,index) $i
  foreach w [winfo children $frm] {
    $w configure -state normal
  }
}
####################
#  CHECK buttons
proc fglCHECKMouseFocus { w } {
  if { [ set state [lindex [$w configure -state] 4]]!="disabled" } {
    global dFrame
    if { $state == "active" || $dFrame($w,class)=="key" } {
      fglCHECKSelect $w
    } else {
      fglCHECKAskFocus $w
      set dFrame($w,ask) 1
      focus $w
    }
  }
}

proc fglCHECKAskFocus { w } {
  global dFrame
  if { $dFrame($w,input) } {
    set id [w2id $w]
    set name [winfo name $w]; set n [string range $name 1 end]
    fglSend $id nextfield $n
  }
}
proc fglCHECKFocusOut { w } {
  if { $w != [focus] && [lindex [$w configure -state] 4]!="disabled" } {
      $w configure -state normal
  }
}

proc fglCHECKSelect { w } {
  global dFrame
  if { [lindex [$w configure -state] 4]=="active" || $dFrame($w,class)=="key" } {
    fglCHECKAskFocus $w
    $w invoke
    if { $dFrame($w,class) == "key" } {
      fglXX $w [lindex $dFrame($w,var) 0]
    } { 
      set val $dFrame($w,var)
      for { set l 0 } \
          { $l < [string length $val] } \
          { incr l } {
        fglXX $w [string index $val $l]
      }
    }
  }
}

proc fgl_CHECKCreate { n C y x l c  S } {
  global dx topWnd dFrame
  set w $topWnd.e${n}
  if { [llength $S] != 3 } {
    set S {1 0 ConfigError}
  }
  set val1 [lindex $S 0 ]
  set val2 [lindex $S 1 ]
  if { [string length $val1] < [string length $val2] } then {
    set ml [string length $val2]
    for { set i [string length $val1] } { $i < $ml } { incr i } {
      set val1 "$val1 "
    }
  } else {
    set ml [string length $val1]
    for { set i [string length $val2] } { $i < $ml } { incr i} {
      set val2 "$val2 "
    }
  }
  set dFrame($w,class) $C
  set dFrame($w,val) "$val1 $val2"
  checkbutton $w \
    -class FglCheckButton \
    -anchor w \
    -width $l  \
    -onvalue $val1 \
    -offvalue $val2 \
    -text [lindex $S 2] \
    -state disabled \
    -relief flat \
    -variable dFrame($w,var)
  place $w \
    -x [fglFormX $x ] \
    -y [fglFormY $y ] \
    -width [expr ($l + 1) * $dx]
  set dFrame($w,ask)   0
  set dFrame($w,input) 0
}

proc fgl_CHECKConfigure { n s {c Black} { r 0 } {h 0} {u 0} {b 0} } {
  global topWnd
  set w $topWnd.e${n}
  if { $s } then {
    $w configure -state normal
  } else {
    $w configure -state disabled
  }
}
proc fgl_CHECKFocus { n h } {
  global topWnd dFrame
  set w $topWnd.e${n}
  set foc [focus]
  myFocus $w
  $w configure -state active
  if { $w == $foc && $dFrame($w,ask) } {
    set dFrame($w,ask) 0
    fglCHECKSelect $w
  }
  set dFrame($w,ask) 0
}
proc fgl_CHECKSelect { n h } {
}
proc fgl_CHECKState { n { s "Normal" } e h } {
  global topWnd dFrame
  set w $topWnd.e${n}
  if { $s } then {
    $w configure -state normal
  } else {
    $w configure -state disabled
  }
  set dFrame($w,input) $s
}

proc fgl_CHECKSet { n v } {
  global topWnd dFrame
  set w $topWnd.e${n}
  if { $v=="*" } {
    $w configure -state disabled
    return
  } elseif { $v=="!" } {
    $w configure -state normal
    return
  }
  set i [lsearch -regexp $dFrame($w,val) "$v *"]
  if { $i == -1 } then {
    set i 1
  }
  set dFrame($w,var) [lindex $dFrame($w,val) $i ]
}

#############
# FIELD_BMP Entry

proc fgl_FIELD_BMPCreate { n C y x l c S } {

  global dx topWnd dpyChannel

  set entry [fgl_EntryCreate $n $C $y $x $l $c "$S" ]

  set xpos [expr $x+$l]
  set w $topWnd.c$n
  if { [llength $S] < 2 } {
    set name "combo.bmp"
    set key  [lindex $S 0]
    if { $key==""} { set key  "F1" }
  } {
    set name [lindex $S 0]
    set key  [lindex $S 1]
  }

  if {[catch {button $w -bitmap [lindex [fglBMPName $name] 1]} msg]} {
    puts stderr "#fgl_FIELD_BMPCreate:$msg"
    button $w -text "\\/"
  }
  $w configure -command "fglX1 $entry 0;fglSendKey $dpyChannel $key"
  place $w -x [expr [fglFormX $x]+[winfo reqwidth $entry]+1] \
           -y [fglFormY $y] \
           -width [expr $dx*1.8] \
           -height [winfo reqheight $entry]
}
proc fgl_FIELD_BMPConfigure { n s c r h u b } {
  fgl_EntryConfigure $n $s $c $r $h $u $b
}
proc fgl_FIELD_BMPSet { n v } {
  fgl_EntrySet $n $v
}
proc fgl_FIELD_BMPState { n s t A } {
  fgl_EntryState $n $s $t $A
}
proc fgl_FIELD_BMPSelect { n h } {
  fgl_EntrySelect $n $h
}
proc fgl_FIELD_BMPFocus { n c } {
  fgl_EntryFocus $n $c
}

####################LABEL widget##############################################
proc fgl_LABELCreate { n C y x l c S } {
  global topWnd 
  global $topWnd.fields
  setxyinfo $n $x $y
  set $topWnd.fields($n,attr) [list $c 0 0 0 0]
  set $topWnd.fields($n,val)  ""
}

proc fgl_LABELConfigure { n s {c Black} { r 0 } {h 0} {u 0} {b 0} {i 0}} {
  global topWnd 
  global $topWnd.fields
  set $topWnd.fields($n,attr) [list $c $r $h $u $b]
  if { [string compare [set $topWnd.fields($n,val)] "" ] } {
    fgl_LABELSet $n [set $topWnd.fields($n,val)]
  }
}

proc fgl_LABELFocus { n h } {
}

proc fgl_LABELSelect { n h } {
}

proc fgl_LABELState { n { s "Normal" } t h {tri 1} {L 0}} {
}

proc fgl_LABELSet { n v } {
  global topWnd 
  global $topWnd.fields
  set l  [getxyinfo $n]
  set la [set $topWnd.fields($n,attr)]
  set $topWnd.fields($n,val) $v
  set c [lindex $la 0]
  set r [lindex $la 1]
  set h [lindex $la 2]
  set u [lindex $la 3]
  set b [lindex $la 4]
  fgl_Label [lindex $l 1] [lindex $l 0] "$v" $c $r $h $u $b
}

proc setxyinfo { w x y } { 
  global topWnd 
  global $topWnd.fields
#faster than setting 2 elements
  set $topWnd.fields($w,y_x) ${y}_${x}
}
proc getxyinfo { w } {
  global topWnd 
  global $topWnd.fields
  if {[info exists $topWnd.fields($w,y_x)]} {
    if {[scan [set $topWnd.fields($w,y_x)] "%d_%d" y x]!=2} {
      error "can't get xypos for $w"
    } else {
      return [list $x $y]
    }
  }
  error "can't find \($w,y_x\) in [fglTopWndList]"
}

######################
# Resizing managment #
######################

proc fglResize { grpId dpyChannel wx wy} {
  global wnd taskRoot
  if {![winfo exists $taskRoot]} return
  regexp "\(\[0-9\]+\)x\(\[0-9\]+\)+.*" [wm geometry .$grpId] dummy cX cY

  if { $wnd($taskRoot,totX) == -1 } {
    set wnd($taskRoot,totX) $wx
    set wnd($taskRoot,totY) $wy
    set wnd($taskRoot,fraX) 0
    set wnd($taskRoot,fraY) 0
  }

  if { $cX == $wx && $cY == $wy } {
    return
  }

  if { $cX >= $wnd($taskRoot,totX) } {
    set cX $wnd($taskRoot,totX)
  }
  if { $cY >= $wnd($taskRoot,totY) } {
    set cY $wnd($taskRoot,totY)
  }
  set ncX $cX
  set ncY $cY
  foreach Co {{X Y} {Y X}} {
    set C [lindex $Co 0]
    set O [lindex $Co 1]
    set wnd($taskRoot,win$C) [set c$C]
    if { [set c$C] < $wnd($taskRoot,tot$C) } {
      fglScrollAppConf $grpId $C
      if { [set c$O] >= $wnd($taskRoot,tot$O) } {
        set nc$O [expr [set c$O] + [lindex [.$grpId.sc$C config -width] 4] + 1]
      }
    } else {
      set wnd($taskRoot,fra$C) 0
      catch {destroy .$grpId.sc$C}
    }
  }
#  bind .$grpId <Configure> "fglResize $grpId $dpyChannel $ncX $ncY"
  wm geometry .$grpId =$ncX\x$ncY
  place $taskRoot -x $wnd($taskRoot,fraX) -y $wnd($taskRoot,fraY)
}

proc fglScrollAppConf { grpId C } {

  global wnd taskRoot

  set tr $taskRoot

  set wnd($tr,fra$C) 0
  set wnd($tr,f$C)   0
  set wnd($tr,l$C)   [expr $wnd($tr,win$C) - 1 ]
  set wnd($tr,lim$C) [expr $wnd($tr,tot$C) - $wnd($tr,win$C) + 1]

  catch {destroy .$grpId.sc$C}

  if { $C == "X" } {
      scrollbar .$grpId.scX -class FglScrollbar \
                            -orient horizontal \
                            -command ";fglScrollAppSet $grpId $tr $C "
      pack .$grpId.scX -side bottom -fill x
  } {
      scrollbar .$grpId.scY -class FglScrollbar \
                            -orient vertical \
                            -command ";fglScrollAppSet $grpId $tr $C "
      pack .$grpId.scY -side right -fill y
  }

 .$grpId.sc$C set $wnd($tr,tot$C) $wnd($tr,win$C) $wnd($tr,f$C) $wnd($tr,l$C)
}

proc fglScrollAppSet { grpId tr C curr} {
 global wnd

 if { $wnd($tr,lim$C) == 0 } {
   return
 }

 if { $curr < 0 } {
   set curr 0
 } else {
   if { $curr > [expr $wnd($tr,lim$C) - 1] } {
     set curr [expr $wnd($tr,lim$C) - 1]
   }
 }

 set wnd($tr,fra$C) [expr 0 - $curr]

 set wnd($tr,f$C) $curr
 if { $wnd($tr,f$C) > [expr $wnd($tr,lim$C) - 1] } {
   set wnd($tr,f$C) [expr $wnd($tr,tot$C) - $wnd($tr,win$C) - 1]
 }

 set wnd($tr,l$C)  [expr $wnd($tr,f$C) + $wnd($tr,win$C) - 1]
 if { $wnd($tr,l$C) > [expr $wnd($tr,tot$C) - 1] } {
   set wnd($tr,l$C) [expr $wnd($tr,tot$C) - 1]
 }

 .$grpId.sc$C set $wnd($tr,tot$C) $wnd($tr,win$C) $wnd($tr,f$C) $wnd($tr,l$C)
 place $tr -x $wnd($tr,fraX) -y $wnd($tr,fraY)
}

######################
# Attribut managment #
######################

set attr(list) [list Blink Bold Rev Under]

proc fglSetAttr {} {
  global attr config

  set attr(name,0) ""
###################
# Initialise name #
###################
  set attr(nb) [llength $attr(list)]
  set attr(nbattr) 1
  for {set i 0} { $i < $attr(nb) } { incr i } {
    set attr(name,$attr(nbattr)) [lindex $attr(list) $i]
    set attr(nbattr) [expr $attr(nbattr)*2]
  }
####################
# Initialize class #
####################
  for {set i 1} { $i < $attr(nbattr) } { incr i } {
    set class fgl
    set p 1
    for {set j 0} { $j < $attr(nb) } { incr j } {
       set class "${class}$attr(name,[expr $i & $p])"
       set p [expr $p*2]
    }
    if { [string match *Rev* $class ] } {
      option add *$class+background  $config(bgEntryHighlight) userDefault
    }
    if { [string match *Blink* $class ] } {
      option add *$class+relief  $attr(FglEntryNormal,relief) userDefault
      option add *$class+borderWidth  $attr(FglEntryNormal,borderwidth) userDefault
    }
    foreach at {background relief borderWidth} {
      if { [set val [option get . ${class}+${at} ""]] == "" } {
        switch "$at" \
          "background"  { set val $config(defaultBg) } \
          "relief"      { set val flat } \
          "borderWidth" { set val 0 }
     }
     set attr($i,[string tolower $at])  $val
    }
  }
  foreach class {FglLabel FglMessage FglError} {
    label .ll -class $class
      foreach at {background relief borderwidth} {
        set attr($class,$at)  [lindex [.ll config -$at] 4]
      }
    destroy .ll
  }
}

proc fglPutAttr { w cl wr c r h u b} {
  global attr config
  set i [ expr $b + $h*2 + $r*4 + $u*8]
  if { ! $i  } {
    $w config -relief      $attr($cl,relief) \
              -borderwidth $attr($cl,borderwidth) \
              -foreground  $config($c) \
              -background  $attr($cl,background)
    return
  }
  if { $r && $c != "White" } {
    $w config -background $config(bgcolor$c)
  } else {
    $w config -foreground $config($c) \
              -background $attr($i,background)
  }
  if { $wr } {
    $w config -relief      $attr($i,relief) \
              -borderwidth $attr($i,borderwidth)
  }
}

# Use by some customers
proc fglExt_MenuFocusText { txt } {
  global topWnd dMenu
  set w $topWnd.menu
  if { [info exists dMenu($w,id,$txt)] } {
    fgl_MenuFocusH $dMenu($w,id,$txt)
  }
}

proc fglExt_source { envvar file } {
   global env
   if { $envvar != "" } {
     if  { [ catch {set path $env($envvar)} ] } {
       set file "./$file"
     } else {
       set file "$path/$file"
     }
   }
   if [ catch { uplevel #0 "source $file" } msg ] {
     catch {destroy .errorso}
     toplevel .errorso
     wm title .errorso "Error in WTK"
     label .errorso.lab1 -text "Source Problem with file $file:"
     label .errorso.lab2 -text "$msg"
     button .errorso.b1 -text "Ok" -command "destroy .errorso"
     pack .errorso.lab1
     pack .errorso.lab2
     pack .errorso.b1
     myFocus .errorso
   }
}

proc fglExt_MenuActived { b } {
  global topWnd dMenu
  set dMenu($topWnd.menu,actived) $b
}

proc fglExt_MenuNextOption { key } {
  global topWnd dMenu
  set dMenu($topWnd.menu,nextoption) $key
}

proc fglExt_MenuLastItem { } {
  global topWnd dMenu lastMenuId
  return $dMenu($topWnd.menu,text,$lastMenuId)
}

#####################bubble help########################################
proc fglBubbleInfo { str w x y } {
  global tk_priv
  return
  puts -nonewline stderr "#$str $w,$tk_priv(fglBubblewin) $x,$tk_priv(fglBubblexold)"
  if [info exists tk_priv(fglBubbletop) ] {
    puts stderr " with top $tk_priv(fglBubbletop)"
  } {
    puts stderr " no top"
  }
}

proc fglBubbleShow { w x y } {
  global tk_priv _task
#puts stderr "#In fglBubbleShow"
  if {![info exists tk_priv(fglBubblewin)]} return
  fglBubbleInfo fglBubbleShow1 $w $x $y
  if {$w != $tk_priv(fglBubblewin)} return
  set tk_priv(fglBubblewin) ""
  if {[set id [w2id $w]]=="" } return
  set tRoot $_task($id,TaskRoot)
  set fbub $tRoot.fglBubbletop
  if {![winfo exists $fbub] } {
    frame $fbub \
      -bg black \
      -borderwidth 1
    label $fbub.e  \
      -class FglLabelBubble \
      -anchor center \
      -bg [fglRes bubbleHelp.color] \
      -borderwidth 0 \
      -padx 2 -pady 2
  }
  if {[set name [fglTBBmap2Name [lindex [$w configure -bitmap] 4] $id]]=="" } return
  if {[set pos [fglTBName2Pos $name] ]=="" } return
  if ![fglRes toolBar.${pos}.comments text] { set text $name }
  $fbub.e configure \
      -text $text \
      -bg [fglRes bubbleHelp.color]
  pack $fbub.e \
      -fill y
  set oldSock $id
  update
  sockCheck $oldSock
  set tbTop $_task($id,tbTop)
  place $fbub -x [expr [winfo x $tbTop] + [winfo x $w] + [winfo reqwidth $w]/2] \
	      -y [expr [winfo y $tbTop] + [winfo reqheight $fbub] + 6] 
  raise $fbub
  set tk_priv(fglBubbletop) $fbub
  set tk_priv(fglBubbleintime) 0
#  puts stderr "#->fglBubbleShow $w $x $y"
  after [fglRes bubbleHelp.disptime] "fglBubbleHide $w $x $y"
}

proc fglBubbleTask { w } {
  global dpyChannel
  if {[set id [w2id $w]]=="" } { return "" }
  if { $dpyChannel != $id } { return "" }
  return $id
}

proc fglBubbleHide { w x y } {
  global tk_priv
  if {![info exists tk_priv(fglBubblewin)]} return
  fglBubbleInfo fglBubbleHide $w $x $y
  if [catch {set fglBubbletop $tk_priv(fglBubbletop)}] return
  catch {destroy $fglBubbletop}
  catch {unset tk_priv(fglBubbletop)}
#  puts stderr "#->fglBubbleHide $w $x $y"
}

proc fglBubbleButton1 { w x y} {
  global tk_priv
  if { [fglBubbleTask $w]=="" } return
  if ![fglRes bubbleHelp.enabled] return
  if {![info exists tk_priv(fglBubblewin)]} return
  fglBubbleInfo fglBubbleButton1 $w $x $y
  fglBubbleHide $w $x $y
}

proc fglBubbleEnter { w x y} {
  global tk_priv
  if { [set id [fglBubbleTask $w]]=="" } return
  if ![fglRes bubbleHelp.enabled] return
  if {[lindex [$w config -state] 4] == "disabled"} return
  set tk_priv(fglBubblewin) $w
  set tk_priv(fglBubblexold) $x
  set tk_priv(fglBubbleyold) $y
  set tk_priv(fglBubblexnew) $x
  set tk_priv(fglBubbleynew) $y
  set tk_priv(fglBubbleintime) 0
  fglBubbleInfo fglBubbleEnter $w $x $y
  if {[set name [fglTBBmap2Name [lindex [$w configure -bitmap] 4] $id]]=="" } return
  fglBubbleInfo fglBubbleEnter1 $w $x $y
  if {[set mstuff [fglTBName2Menu $name $id]]!="" } { catch {eval $mstuff} }
  fglBubbleInfo fglBubbleEnter2 $w $x $y
  fglBubbleInfo fglBubbleEnter3 $w $x $y
  after 100 "fglBubbleWait $w"
  fglBubbleInfo fglBubbleEnter4 $w $x $y
}

proc fglBubbleLeave { w x y} {
  global tk_priv
  if { [fglBubbleTask $w]=="" } return
  if ![fglRes bubbleHelp.enabled] return
  if {![info exists tk_priv(fglBubblewin)]} return
  fglBubbleInfo fglBubbleLeave $w $x $y
  set tk_priv(fglBubblewin) {}
  set tk_priv(fglBubblexold) {}
  set tk_priv(fglBubbleyold) {}
  fglBubbleHide $w $x $y
}

proc fglBubbleWait { w } {
   global tk_priv dpyChannel
  fglBubbleInfo fglBubbleWait $tk_priv(fglBubbleintime) \
        $tk_priv(fglBubblexnew) $tk_priv(fglBubbleynew)
   if { $tk_priv(fglBubblexnew)!= $tk_priv(fglBubblexold) \
     || $tk_priv(fglBubbleynew)!= $tk_priv(fglBubbleyold) } {
      set tk_priv(fglBubblexold)   $tk_priv(fglBubblexnew)
      set tk_priv(fglBubbleyold)   $tk_priv(fglBubbleynew)
      set tk_priv(fglBubbleintime) 0
   } else {
      if { ![winfo exists $w] } {
        set tk_priv(fglBubbleintime) 0
        return
      }
      if { [fglBubbleTask $w]=="" } return
      incr tk_priv(fglBubbleintime) 100
      if  { [fglRes bubbleHelp.offtime] <= $tk_priv(fglBubbleintime) } {
        if { $tk_priv(fglBubblewin)!=""} {
          fglBubbleShow $tk_priv(fglBubblewin) $tk_priv(fglBubblexnew) \
                        $tk_priv(fglBubbleynew)
        }
        return
      }
   }
   after 100 "fglBubbleWait $w"
}

proc fglBubbleMotion { w x y } {
   global tk_priv
  if { [fglBubbleTask $w]=="" } return
  if ![fglRes bubbleHelp.enabled] return
  if {![info exists tk_priv(fglBubblewin)]} return
  fglBubbleInfo fglBubbleMotion $w $x $y
  if { $w != $tk_priv(fglBubblewin) } return
  set tk_priv(fglBubblexnew) $x
  set tk_priv(fglBubbleynew) $y
}

#########################fglReport##############################################
proc fgl_ReportBegin { args } {
  global fglWtkClient
  if $fglWtkClient {
    global dpyChannel
    lappend args -id $dpyChannel -reportArray fglReport
    if {[catch "fglwtk_ReportBegin $args" msg]} {
      global errorInfo
      puts stderr "#fglwtk_ReportBegin:$msg\n$errorInfo"
    }
  }
}
proc fgl_ReportPageBegin { args } {
  global fglWtkClient
  if $fglWtkClient {
    global dpyChannel
    lappend args -id $dpyChannel
    if {[catch "fglwtk_ReportPageBegin $args" msg]} {
      global errorInfo
      puts stderr "#fglwtk_ReportPageBegin:$msg\n$errorInfo"
    }
  }
}
proc fgl_ReportRow { args } {
  global fglWtkClient
  if $fglWtkClient {
    global dpyChannel
    lappend args -id $dpyChannel
    if {[catch "fglwtk_ReportRow $args" msg]} {
      global errorInfo
      puts stderr "#fglwtk_ReportRow:$msg\n$errorInfo"
    }
  }
}
proc fgl_ReportPageEnd { args } {
  global fglWtkClient
  if $fglWtkClient {
    global dpyChannel
    lappend args -id $dpyChannel
    if {[catch "fglwtk_ReportPageEnd $args" msg]} {
      global errorInfo
      puts stderr "#fglwtk_ReportPageEnd:$msg\n$errorInfo"
    }
  }
}
proc fgl_ReportEnd { args } {
  global fglWtkClient
  if $fglWtkClient {
    global dpyChannel
    lappend args -id $dpyChannel
    if {[catch "fglwtk_ReportEnd $args" msg]} {
      global errorInfo
      puts stderr "#fglwtk_ReportEnd:$msg\n$errorInfo"
    }
  }
}

#########################fglToolbar#############################################

proc fglTBButCreate { num s bmp } {
#global fgl_tb
  global dpyChannel fglWtkClient
  set id $dpyChannel
  global _task
  set tbNum $_task($id,tbNum)
  set tbTop $_task($id,tbTop)
#  set fgl_tb($s) "$num $bmp.bmp"
#  puts stderr "#fgl_tb($s) $fgl_tb($s)"
#  puts stderr "#fglTBButCreate $id $num $s $bmp"
  set _task($id,TB,s2pos,$s) $num
  set _task($id,TB,s2bmp,$s) $bmp.bmp
  set _task($id,TB,s2menu,$s) ""
  set _task($id,TB,bmp2s,$bmp.bmp) $s
#  puts stderr "#TBBButCreate _task($id,TB,bmp2s,$bmp.bmp) $s"
  if { $bmp=="fglSeparator" } {
    set tbNum [expr $tbNum + [fglRes toolBar.sep]]
  } else {
    set but $tbTop.$num
    set _task($id,TB,wnd2s,$but) $s
    if {[winfo exists $but] || ![winfo exists $tbTop] }  return
#    if $fglWtkClient { set pre @ } { global fgldir; set pre %$fgldir/ }
    if {[catch {\
      button $but \
        -class FglToolbarButton \
        -bitmap [lindex [fglBMPName $bmp.bmp] 1] \
        -state disabled\
      } msg]} {
#      puts stderr "#button $msg";
       return
    }
#        -bitmap ${pre}[fglRes toolBar.dir]/$bmp.bmp 
    place $but \
      -x [expr $tbNum * [fglRes toolBar.sizeX] + [fglRes toolBar.gapX] ]\
      -y [fglRes toolBar.gapY]
    set tbNum [expr $tbNum + 1.0]
  }
  set _task($id,tbNum) $tbNum
}

proc fglTBBmap2Name { bitmap {id "" }} {
#  global fgl_tb
#  foreach i [array names fgl_tb] {
#    set file1  [fglTBName2Bmap $i]
#    set file2  [file tail [string range $bitmap 1 end]]
#    puts stderr "#$file1,$file2"
#    if {$file1==$file2} { return $i }
#  }
#  return ""
  global _task dpyChannel;
  if { $id == "" } { set id $dpyChannel }
  if { ! [regexp ".*\[\\\\/\]\(\[a-zA-Z_\.0-9\]+\)" $bitmap dummy bmp ] } {
    set bmp $bitmap
  }
#  set bmp [file tail [string range $bmap 1 end]]
#  puts stderr "#TBBmap2Name id $id bmap $bitmap  bmp $bmp"
  if [catch { set _task($id,TB,bmp2s,$bmp) } name] {return ""}
  return $name
}
proc fglTBName2Menu { name id {newvalue "" }} {
#puts stderr "#fglTBName2Menu name $name id $id newvalue $newvalue"
  global _task dpyChannel;
  if { $id=="" } { set id $dpyChannel }
  if [catch {set _task($id,TB,s2menu,$name) } menustuff] {return ""}
  if {$newvalue != "" } {
    set menustuff [set _task($id,TB,s2menu,$name) $newvalue]
  }
  return $menustuff
}

proc fglTBWnd2Name { wnd } {
  global _task dpyChannel; set id $dpyChannel
#puts stderr "#fglTBWnd2name wnd $wnd"
  if [catch { set _task($id,TB,wnd2s,$wnd) } name] {return ""}
  return $name
}

proc fglTBName2Bmap { name } {
#  global fgl_tb
#  if [catch { set fgl_tb($name) } el] {return ""}
#  return [lindex $el 1]
  global _task dpyChannel; set id $dpyChannel
#puts stderr "#fglTBName2Bmap name $name"
  if [catch { set _task($id,TB,s2bmp,$name) } bitmap] {return ""}
  return $bitmap
}

proc fglTBName2Pos { name } {
#  global fgl_tb
#  if [catch { set fgl_tb($name) } el] {return -1}
#  return [lindex $el 0]
  global _task dpyChannel; set id $dpyChannel
#puts stderr "#fglTBName2Pos name $name"
  if { [catch { set _task($id,TB,s2pos,$name) } pos] \
     && [catch { set _task($id,TB,s2pos,[lindex $name 0]) } pos] \
     && [catch { set _task($id,TB,s2pos,[lindex $name 1]) } pos] \
     && [catch { set _task($id,TB,s2pos,[string range [lindex $name 1] 4 end]) } pos]  } {
#    puts stderr "pos $pos"
    return ""
  }
  return $pos
}

proc fglTBCreate { id taskRoot wx } {
#  puts stderr "#fglTBCreate $wx"
  global _task fglWtkClient
  set f $taskRoot.tb
  frame $f \
    -width  $wx \
    -height [fglRes toolBar.sizeY] \
    -relief raised \
    -borderwidth  1
  place $f \
    -x 0 \
    -y 0
  set _task($id,tbNum) 0.0
  set _task($id,tbTop) $f
#  raise $f
  set max [expr ($wx / ([fglRes toolBar.sizeX] + [fglRes toolBar.gapX])) + 1]
  set txt ""
  set bmp ""
  for { set i 0 } { $i < $max } { incr i } {
    if { ! [fglRes toolBar.${i}.key txt] && ! [fglRes toolBar.${i}.text txt] } {
      continue
    }
    if ![fglRes toolBar.${i}.bmp bmp]  continue
    fglTBButCreate $i "$txt" $bmp
  }
}

proc fglTBReset { } {
#  puts stderr "#fglTBReset"
#  global  fgl_tb
#  foreach i [array names fgl_tb] {
#    fglTBConfigure $i { } disabled
#  }
  if ![fglRes toolBar.enabled] return
  global taskRoot
  foreach i [winfo children $taskRoot.tb] {
    fglTBConfigure [fglTBWnd2Name $i] { } disabled
  }
}

proc fglTBConfigure { name { cmd { } } { state normal } {menustuff "" } } {
#  puts stderr "#fglTBConfigure name $name cmd $cmd state $state menustuff $menustuff"
  if ![fglRes toolBar.enabled] { return 0 }
  global taskRoot fglWtkClient
  set f $taskRoot.tb
  if { [set pos [fglTBName2Pos $name]] == "" } { return }
  catch { $f.$pos configure -state $state -command $cmd }
  if { $menustuff != "" } { fglTBName2Menu $name "" $menustuff }
  if !$fglWtkClient {
    if { $state=="disabled" } {
      catch { $f.$pos configure -background gray30 }
    } {
      catch { $f.$pos configure -background #c0c0c0  }
    }
  }
  if { $state == "normal" } { return $pos }
  return 0
}

##############################################################################
# startup

fglSetClientSpecifics
catch { option readfile $fglConfigFile interactive }
fglOptionAdd2
fglOptionAdd
fglSetFont

#fglBindCpy
fglSetDerivedClasses
fglBindDefault
fglSetAttr

if { $fglWtkClient } {
  if { $wtk_currsock != "none" } {
    catch "sockOpen $wtk_currsock"
  }
  catch {fglwtk_HideStartUp}
}
