DEFINE curr_page    INTEGER,
       continue_rep SMALLINT,
       display_rep  SMALLINT,
       openwin      SMALLINT

FUNCTION fgl_report_start(pagelength,topmargin,bottommargin,
                          leftmargin,rightmargin) 
  DEFINE pagelength,topmargin,bottommargin,leftmargin,rightmargin INTEGER

  OPEN WINDOW fglreport AT 1,0 WITH 24 ROWS, 80 COLUMNS
    ATTRIBUTE(FORM LINE FIRST)

  OPEN FORM fglreport FROM "fglreport"

  DISPLAY FORM fglreport

  LET openwin      = 1
  LET curr_page    = 0
  LET continue_rep = FALSE
  LET display_rep  = TRUE

END FUNCTION

FUNCTION fgl_report_show_page(n,p)
  DEFINE 
    i INTEGER,
    n INTEGER,
    dsppage SMALLINT,
    p ARRAY[100] OF VARCHAR(256),
    oldint  SMALLINT

  IF NOT display_rep THEN
    RETURN
  END IF

  LET oldint = int_flag
  LET curr_page = curr_page + 1

  CURRENT WINDOW IS fglreport

  IF curr_page > fgl_report_maxpage() THEN
    CALL fgl_report_storelength(curr_page,n)
    FOR i = 1 TO n
       CALL fgl_report_storeline(curr_page,i,p[i])
    END FOR
  END IF

  IF n < 1 THEN RETURN END IF

  let dsppage=1
  WHILE dsppage 
    LET dsppage = 0
    CALL set_count(n)

    DISPLAY ARRAY p TO LINES.* 

      ON KEY(ACCEPT,ESCAPE,f6)
        LET i = curr_page + 1
        IF i > fgl_report_maxpage() THEN
          IF continue_rep THEN
            LET dsppage = 2
            ERROR "This is the last page"
          ELSE
            LET dsppage = 0
          END IF
        ELSE
          LET curr_page = i
          LET dsppage = 1
        END IF
        EXIT DISPLAY

      ON KEY(f5)
        LET i = curr_page - 1
        IF i < fgl_report_minpage() THEN
          ERROR "This is the first page"
          LET dsppage = 2
        ELSE
          LET curr_page = i
          LET dsppage = 1
        END IF
        EXIT DISPLAY
    END DISPLAY
 
    IF dsppage = 1 THEN
      LET n = fgl_report_givelength(curr_page)
      FOR i = 1 TO n
        LET p[i] = fgl_report_giveline(curr_page,i)
      END FOR
    END IF
  END WHILE

  IF int_flag AND NOT oldint THEN
    LET display_rep = FALSE
  END IF

END FUNCTION

FUNCTION fgl_report_continue(val) 

  DEFINE val SMALLINT

  LET continue_rep = val

END FUNCTION

FUNCTION fgl_report_finish() 

  DEFINE 
    i INTEGER,
    rp RECORD
      n         INTEGER,
      p ARRAY[100] OF VARCHAR(256)
    END RECORD

  LET curr_page = fgl_report_maxpage()
  IF continue_rep AND NOT int_flag AND curr_page != 0 THEN
    LET rp.n      = fgl_report_givelength(curr_page)
    FOR i = 1 TO rp.n
      LET rp.p[i] = fgl_report_giveline(curr_page,i)
    END FOR
    LET curr_page = curr_page - 1
    CALL fgl_report_show_page(rp.*)
  END IF
    

  IF openwin THEN
    CLOSE WINDOW fglreport
  END IF
  LET openwin=0

  CALL fgl_report_freedata()

END FUNCTION

FUNCTION fgl_report_use_temptable()

  RETURN

END FUNCTION
